#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#L:/66_INP/m03__Metaznaky.py
"""
Příkazy zadávané ve výpisech kapitoly:
03  Využití metaznaků
"""
import dbg; dbg.start_mod(1, __name__)
###########################################################################q
import rtc


#Výpis 3.1:	Demonstrace vlastností množin znaků
###########################################################################q
rtc.bac(
    rtc.LAS(
        r'Znak o následovaný jiným znakem než o',
        [r'o[^o]'],
        [],
        [r'Okolo "Hradce" v malé zahrádce']
    ),
    rtc.LAS('\n'
        r'Velké ASCII písmeno následované malým ASCII písmenem',
        [r'[A-Z][a-z]'],
        [],
        [r'Okolo "Hradce" v malé zahrádce']
    ),
    rtc.LAS('\n'
        r'Souhláska. samohláska, souhláska',
        [r'[^aeiouyáé][aeiouyáé][^aeiouyáé]'],
        [],
        [r'Okolo "Hradce" v malé zahrádce']
    ),
    rtc.LAS('\n'
        r'Ne ASCII znak',
        [r'[^\x00-\x7f]'],
        [],
        [r'Příliš žluťoučký kůň úpěl ďábelské ódy']
    ),
    rtc.LAS('\n'
        r'Tečka nebo stříška nebo minus',
        [r'[.^-]'],
        [],
        [r'Tečka . stříška ^ a minus -.']
    ),
    rtc.LAS('\n'
       r"Metaznaky s výjimkou '\' a ']' zastupují samy sebe",
        [r'[.^+?*$|([{}\]\\)]'],
        [],
        [r'''!"#$%&'()*+,-./0123456789:;<=>?@[\]^_`{|}~''']
    ),
    rtc.LAS('\n'
        "Znak ze tří souvislých bloků + dva sólisté",
        [r'[a-di-lntx-z]'],
        [],
        [r'abcdefghijklmnopqrstuvwxyz']
    )
)



#Výpis 3.2:	Ukázky použití skupinových znaků
###########################################################################q
rtc.bac(
    rtc.LAS(
        r'Nebílý znak následovaný bílým a opět nebílým',
        [r'\S\s\S'],
        [],
        [r'Okolo "Hradce" v malé zahrádce']
    ),
    rtc.LAS('\n'
        r'Písmeno následované dvěma nepísmeny a písmenem',
        [r'\w\W\W\w'],
        [],
        [r'Okolo "Hradce" v malé zahrádce']
    ),
    rtc.LAS('\n'
        r'Bílý znak obklopený dvojicemi libovolných znaků',
        [r'..\s..'],
        [],
        [r'Okolo "Hradce" v malé zahrádce']
    ),
    rtc.LAS('\n'
        r'Vyhledává hexadecimální číslice',
        [r'[\dA-Fa-f]'],
        [],
        [r'Šestnáctkově 3AB.']
    )
)



#Výpis 3.3:	Použití hranic textu
###########################################################################q
rtc.bac(
    rtc.LAS(
        r'Hranice slova následovaná posloupností písmen a hranicí slova',
        [r'\b\w+\b'],
        [],
        [r'Okolo "Hradce" v malé předzahrádce!']
    )
)



#Výpis 3.4:	Dva ekvivalentní způsoby zápisu téhož regulárního výrazu
###########################################################################q
import re
a = re.compile(r"""\d +  # Celá část
                   \.    # Desetinná tečka
                   \d *  # Desetinná část""", re.X)

b = re.compile(r"\d+\.\d*")



#Výpis 3.5:	Ukázky použití kvantifikátorů
###########################################################################q
rtc.bac(
    rtc.LAS(
        r'Nejméně jedno o, horní počet neomezen',
        [r'aho+j'],
        [],
        [r'Vodácký pozdrav: ahoj ahooj ahoooj ahooooj ahoooooj atd.']
    ),
    rtc.LAS('\n'
        r'V pozdravu jsou 2–4 po sobě jdoucí o',
        [r'aho{2,4}j'],
        [],
        [r'Vodácký pozdrav: ahoj ahooj ahoooj ahooooj ahoooooj atd.']
    ),
    rtc.LAS('\n'
        r'Alespoň 2 ASCII znaky za sebou',
        [r'[\x21-\x7F]{2,}'],
        [],
        [r'Příliš žluťoučký kůň úpěl ďábelské ódy']
    ),
    rtc.LAS('\n'
        r'Bílé znaky mezi nimiž je nejméně jeden ne bílý',
        [r'\s\S+\s'],
        [],
        [r'Příliš žluťoučký kůň úpěl ďábelské ódy']
    ),
    rtc.LAS('\n'
        r'Vyhledání hexadecimálních čísel',
        [r'\b[\dA-Fa-f]+\b'],
        [],
        [r'Šestnáctkově 3AB - abeceda ale ne.']
    ),
    rtc.LAS('\n'
        r'Bezpečné vyhledání hexadecimálních čísel',
        [r'\b0x[\dA-Fa-f]+\b'],
        [],
        [r'Šestnáctkově 0x3AB - abeceda ale ne.']
    )
)



#Výpis 3.6:	Zdráhavé versus hladové kvantifikátory
###########################################################################q
rtc.bac(
    rtc.LAS(
        r'Text začínající a končící malým L – hladový kvantifikátor',
        [r'l.+l'],
        [],
        [r'Příliš žluťoučký kůň úpěl ďábelské ódy']
    ),
    rtc.LAS('\n'
        r'Text začínající a končící malým L – zdráhavý kvantifikátor',
        [r'l.+?l'],
        [],
        [r'Příliš žluťoučký kůň úpěl ďábelské ódy']
    ),
    rtc.LAS('\n'
        r'Text začínající a končící malým L – lakomý kvantifikátor',
        [r'l.++l'],
        [],
        [r'Příliš žluťoučký kůň úpěl ďábelské ódy']
    ),
    rtc.LAS('\n'
        r'Samostatná celá čísla – lakomý kvantifikátor',
        [r'\b\d++\b'],
        [],
        [r'Tuna má 1000 kg a je to 10násobek centu, jenž má 100 kg.']
    )
)



#Výpis 3.7:	Definice alternativních textů
###########################################################################q
rtc.bac(
    rtc.LAS(
        r'',
        [r'Praha|Brno|Ostrava'],
        [],
        [r'Jezdil na tratích Praha-Brno a Praha-Ostrava']
    )
)



#Výpis 3.0:	Popisek
###########################################################################q
"""
Je uloženo v souboru
#L:/66_INP/xxx.py
"""
#Kapitola 3.0:	Název
#--------------------------------------------------------------------------q
                                                                       #SYNC
###########################################################################q
dbg.stop_mod(1, __name__)
