#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#L:/66_INP/m09__Modul_pathlib.py
"""
Příkazy zadávané ve výpisech kapitoly:
09  Modul pathlib
"""
import dbg; dbg.start_mod(1, __name__)
###########################################################################q



#Výpis 9.1:	Hierarchie dědění tříd v balíčku pathlib
###########################################################################q
#                 ┏━━━━━━━━━━┓
#        ┌───────▷┃ PurePath ┃◁──────┐
#        │        ┗━━━━┯━━━━━┛       │
#        │             △             │
# ┏━━━━━━┷━━━━━━━━┓    │    ┏━━━━━━━━┷━━━━━━━━┓
# ┃ PurePosixPath ┃    │    ┃ PureWindowsPath ┃
# ┗━━━━━━┯━━━━━━━━┛    │    ┗━━━━━━━━┯━━━━━━━━┛
#        △          ┏━━┷━━━┓         △
#        │   ┌─────▷┃ Path ┃◁────┐   │
#        │   │      ┗━━━━━━┛     │   │
#        │   │                   │   │
#   ┏━━━━┷━━━┷━━┓           ┏━━━━┷━━━┷━━━━┓
#   ┃ PosixPath ┃           ┃ WindowsPath ┃
#   ┗━━━━━━━━━━━┛           ┗━━━━━━━━━━━━━┛



#Výpis 9.2:	Konstrukce instancí tříd PurePath a Path
###########################################################################q
from pathlib import *
PurePath(), Path()          # Rodič vytváří instanci aktuálního potomka
PurePosixPath() # Abstraktní cesty lze vytvářet i pro jiný druh systému
PosixPath()     # Konkrétní cesty však pro jiný systém vytvářet nelze
PurePath('c:', 'Složka', 'Podsložka/PodPod') # Zadané cesty sloučí
PurePath('a///b/c/./d/')    # Odebere přebytečné separátory a '.'
PurePosixPath('/etc', '/usr', 'bin') # Předchůdce absolutní cesty ignoruje
PurePath('c:/foo', '/Windows')  # U Windows však zachová disk
PurePath('c:/foo', 'd:')    # Je-li disk přepsán, ignoruje se ten původní
PurePath('a//b/./c/../d')   # "." odebere, ale ".." ne
# Nehlídá nesmyslné vložení absolutní okenní cesty do posixové
PurePosixPath('/etc', r'c:\aux', 'bin') # Vložil posixovou složku r'c:\aux'



#Výpis 9.3:	Prezentace a reprezentace vytvořených cest
###########################################################################q
pwp1 = PureWindowsPath(r'A:\B\C');      pwp2 = PureWindowsPath(r'a:/b/c')
ppp1 = PurePosixPath  ( '/A/B/C');      ppp2 = PurePosixPath  ( '/a/b/c')
print(f'pwp1 - Systémový podpis={pwp1!r},  uživatelský podpis={pwp1!s}\n'
      f'pwp2 - Systémový podpis={pwp2!r},  uživatelský podpis={pwp2!s}\n'
      f'ppp1 - Systémový podpis={ppp1!r},  uživatelský podpis={ppp1!s}\n'
      f'ppp2 - Systémový podpis={ppp2!r},  uživatelský podpis={ppp2!s}')
pwp1.as_posix(),   pwp2.as_posix()  # Žádost o zobrazení v posixové notaci
f'{pwp1==pwp2 = },   {ppp1==ppp2 = }' # Cesty ve Windows porovnává odlišně



#Výpis 9.4:	Demonstrace významu jednotlivých vlastností
###########################################################################q
p = PureWindowsPath('L:/Data/Downloads/pathlib.tar.gz')
p.drive, p.root, p.anchor, p.parent, p.name
pp = p.parents;  print(*[f"pp[{i}]='{pp[i]}', " for i in range(len(pp))])
f'{p.stem=}, {p.suffix=}, {p.suffixes=}'
p.parts
p = PureWindowsPath('//host/share/dir/foo.txt')
p.drive, p.root, p.anchor, p.parent
PureWindowsPath('c:/').parent, PureWindowsPath('rel').parent
p = PurePosixPath('/Data/Downloads/pathlib.tar.gz')
p.drive, p.root, p.anchor, p.parent, p.name



#Výpis 9.5:	Demonstrace operací s cestami
###########################################################################q
# Abychom zkrátili text následujících příkazů,
# uložíme odkazy na třídy do pomocných proměnných PWP a PPP
PWP = PureWindowsPath;    PPP = PurePosixPath;     paw = PWP('Abc');\
p0w = PWP('C:/Win');   p1w = PWP('rel_win/end');   p2w = PWP('rel_win/END');\
p0p = PPP('/posix');   p1p = PPP('rel_pos/end');   p2p = PPP('rel_pos/END')
print(f'{(paw < p0w < p1w == p2w) = }\n{      (p0p < p1p >  p2p) = }')
# Objekt cesty (PurePath) a string definující cestu jsou různé objekty
print(f"{p0w=},  {(p0w=='C:/Win')=}")
print(f'{(p0w / p1p / paw) = }\n{(p0p / p1w / paw) = }')
p0p / p0w / p1p  # Vznikne posixová cesta se složkou nazvanou 'C:\'
p0w / p0p / p1w  # Disk zůstává, vymění jen kořenovou složku



#Výpis 9.6:	Ukázky použití použití konverze na URI
###########################################################################q
# Budeme používat proměnné z výpisu 8.5 na straně 105
p0w.as_uri(),   p0p.as_uri()



#Výpis 9.7:	Ukázky použití zjišťovacích metod
###########################################################################q
# Budeme používat proměnné z výpisu 8.5 na straně 105
p0w.is_absolute(), p1w.is_absolute(), p0p.is_absolute(), p1p.is_absolute()
# Test relativnosti jedné cesty vůči druhé
ab = PurePath('A:/B');   abc = PurePath('A:/B/C');   c = PurePath('C')
print(f'{ab.is_relative_to(abc)=},  {abc.is_relative_to(ab)=}\n'
      f'{c .is_relative_to(abc)=},  {c  .is_relative_to(ab)=}')
# Test detekce rezervovaných (a tím pádem zakázaných) názvů
print(*[f'{p}:{p.is_reserved()}' for p in
      (p0w, PWP('C:/aux/tmp'), PWP('C:/aux.txt'), PPP('/aux'))], sep='  -  ')
# Test vyhovění zadanému vzoru
p1 = '/A/B/C/FILE.txt';    pw1=PWP(p1);    pp1 = PPP(p1);    m1 = 'file.*'
pw1.match(m1),   pp1.match(m1)   # U Windows na velikosti znaků nezáleží
PurePath('/a.py').match('/*.py'),  PurePath('b/a.py').match('/*.py')



#Výpis 9.8:	Ukázky použití sestavovacích metod
###########################################################################q
# Slučování
PurePath('/etc').joinpath('init', 'apache2')
PurePath('/etc').joinpath('/init', 'apache2')
# Relativizace cesty
p = PurePath('/etc/passwd');   p.relative_to('/'),   p.relative_to('/etc')
p.relative_to('/usr')
# Záměna celého názvu
(PurePath('c:/Downloads/pathlib.tar.gz').with_name('setup.py'),
 PurePath('c:/Downloads/').with_name('setup.py'))
PurePath('c:/').with_name('setup.py')
# Záměna čistého názvu bez přípony
PurePath('c:/Downloads/pathlib.tar.gz').with_stem('lib')
PurePath('Downloads/readme').with_stem('Read_me')
# Záměna, přidání a odebrání přípony
PurePath('c:/Downloads/pathlib.tar.gz').with_suffix('.bz2')
(p := PurePath('README').with_suffix('.txt')),   p.with_suffix('')



#Výpis 9.0:	Popisek
###########################################################################q
"""
Je uloženo v souboru
#L:/66_INP/xxx.py
"""
##### Kapitola 9.0:	Název
#--------------------------------------------------------------------------q
                                                                       #SYNC
###########################################################################q
dbg.stop_mod(1, __name__)
