#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#L:/66_INP/m10__Konkrétní_cesty.py
"""
Příkazy zadávané ve výpisech kapitoly:
10  Konkrétní cesty a práce se složkami a soubory
"""
import dbg; dbg.start_mod(1, __name__)
###########################################################################q



#Výpis 10.1:	Zjišťování a nastavování základních informací
###########################################################################q
from pathlib import *
# Vytvoření cest k aktuální pracovní složce a k uživatelské domovské složce
(dot := Path(),    cwd := Path.cwd(),    home := Path.home())
(dota := dot.absolute())    # Převod bez symbolických odkazů (simlinks)
(dotr := dot.resolve())     # Převod s "rozbalením" symbolických odkazů
# Rozpoznání různých podob odkazů na stejný soubor
dot.samefile(cwd), dot.samefile(dota), dot.samefile(dotr), dot.samefile(home)
dbgp = Path('dbg.py');   f'{dbgp.absolute()!r}.exists() = {dbgp.exists()}'
# Při převodu na absolutní cestu na existenci souboru na cestě nezáleží
dbgx = Path('dbg.xx');   f'{dbgx.absolute()!r}.exists() = {dbgx.exists()}'
# Neexistující objekt není ani složka, ani soubor
print(f'{dot.is_dir() =!s:5}, {dbgp.is_dir() =!s:5}, {dbgx.is_dir() =!s:5}\n'
      f'{dot.is_file()=!s:5}, {dbgp.is_file()=!s:5}, {dbgx.is_file()=!s:5}')



#Výpis 10.2:	Manipulace se soubory a složkami
###########################################################################q
a = Path('A');   abc = Path(a,'B/C');   abcd = Path(abc,'D');   a, abc, abcd
a.mkdir()               # Vytvoření složky A
abcd.mkdir()            # Chybějící složky na cestě vyvolají chybu
abcd.mkdir(parents=1)   # Mohu ale požádat o jejich vytvoření
f'{abc.exists() = },    {abcd.exists() = }'
abc.mkdir()             # Složka již byla vytvořena
abc.mkdir(exist_ok=1)   # Zadáno, aby mu to nevadilo, důležité je, že existuje
x = Path(abcd, 'x.txt').absolute();      print(f'{x = }')
x.touch();   x.exists() # Vytvoření souboru x.txt ve složce `abcd`
y = x.rename('y.py').absolute() # Soubor A/B/C/D/x.txt přesunut a přejmenován
print(f'{y = },   {y.exists() = },   {x.exists() = }')
(X:=Path('X')).mkdir()  # Vytvoří novou složku na cestě `X`
XA = abc.rename(X / a)  # Složka `A/B/C` přesunuta a přejmenována na `X/A`
XA.replace('A/B/C')     # Přesune složku X/A zpět do A/B a přejmenuje na C
abcd.exists()           # Vrátili jsme se tak do původního stavu s A/B/C/D
y.unlink();  y.exists() # Smazání souboru y.py
X.rmdir()    # Po přesunu složky X/A je už prázdná => můžeme ji odstranit
import os; os.removedirs(abcd); a.exists() # Odstranění hierarchie složek



#Výpis 10.3:	Procházení obsahu složky
###########################################################################q
# Soubory (a složky) v aktuální složce, které nejsou skripty Pythonu
dot = Path();    [p.name for p in dot.iterdir() if p.suffix != '.py']
[p.name for p in dot.iterdir() if len(p.name) < 15]
# Soubory v aktuální složce, jejichž názvy začínají 'm00'
dot.glob('m00*.*')            # Vrátí generátor
print(*dot.glob('m00*.*'))    # Tiskne uživatelské podpisy, takže jména
sorted(dot.glob('m00*.*'))    # Vrátí seřazený seznam objektů
# Demonstrace náhledu do podsložek
# Vyrobí hierarchii složek a soubor ekvivalentní těm z minulých výpisů
a = Path('A');   abcd = Path('A/B/C/D');   abcd.mkdir(parents=1)
x = Path(abcd, 'x.txt');      x.touch()
print(*a.rglob('*'), sep=' - ')  # Hvězda zahrnuje i soubory bez přípony



#Výpis 10.4:	Primitivní zápis a čtení dat
###########################################################################q
# Používá proměnné `dot`, `a`, `abcd` a `x` z minulého výpisu
txt  = 'Okolo Hradce v malé zahrádce'
x.write_text(txt)   # Zapisuje v kódování UTF-8, vrací počet zapsaných znaků
x.read_text()       # Přečte ze souboru před chvílí zapsaný text
x.read_bytes()      # Přečte zapsaná data jako posloupnost bajtů
b = b'(' + _ + b')' # Aby byla vidět změna, dá na začátek a konec závorku
x.write_bytes(b)    # Zapíše posloupnost bajtů, vrací počet zapsaných bajtů
x.read_text()       # Přečte uložená data jako text


#Výpis 10.0:	Popisek
###########################################################################q
"""
Je uloženo v souboru
#L:/66_INP/xxx.py
"""
##### Kapitola 10.0:	Název
#--------------------------------------------------------------------------q
                                                                       #SYNC
###########################################################################q
dbg.stop_mod(1, __name__)
