#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#L:/66_INP/m11__Datové_proudy.py
"""
Příkazy zadávané ve výpisech kapitoly:
11  Datové proudy
"""
import dbg; dbg.start_mod(1, __name__)
###########################################################################q



#Výpis 11.1:	Pomocné objekty pro následující příklady
###########################################################################q
from pathlib import Path
p = Path('z.txt')   # Relativní cesta k souboru, s nímž budeme pracovat
o = Path('y.txt')   # Cesta k pomocnému souboru
from os.path import getsize   # Zjistí velikost souboru na zadané cestě
t1 = 'Okolo Hradce v malé zahrádce'  # Text, jenž bychom ukládali
b1 = bytes(range(65, 91)); b1  # Bajtový objekt s velkými písmeny abecedy
p.write_bytes(b1)   # Příprava souboru - víme, že existuje a je neprázdný
o.unlink(True);     o.exists()       # Víme, že soubor již neexistuje



#Výpis 11.2:	Demonstrace otevírání textových souborových datových proudů
###########################################################################q
tr = open(p)        # Implicitní nastavení: textový proud určený ke čtení
type(tr),   (t2:=tr.read()),   tr.close() # Přečtení obsahu a zavření proudu
getsize(p)          # Soubor stále existuje a je neprázdný
ta = open(p, 'a')   # Textový proud určený k zápisu na konec souboru
type(ta),    ta.write(t1),    ta.close() # Zápis dat a zavření proudu
getsize(p)          # Velikost souboru poněkud narostla
tw = open(p, 'w')   # Textový proud určený k zápisu do souboru na cestě `p`
getsize(p)          # Po otevření byl soubor vyčištěn
type(tw),    tw.write(t1),    tw.close()    # Zápis dat a zavření proudu
getsize(p)          # Nyní je tam jen text z proměnné `t1`
tx = open(p, 'x')   # Vzbouří se, protože soubor již existuje
tx = open(o, 'x')   # Soubor neexistoval a byl vytvořen
type(tx),    tx.write(t2),    tx.close()    # Zápis dat a zavření proudu
t_ = open(o, 'rw')  # Takto nelze proud pro čtení i zápis zadávat
t_ = open(o, '+')   # Chybí informace, jestli na počátku mazat, či nechat
t_ = open(o, 'a+'); print(f'{type(t_)=}, {o=!s}, {getsize(o)=}, {t_.read()=}')
t_.write(t1), t_.close(), f'{getsize(o)=}'    # Zápis dat a zavření proudu



#Výpis 11.3:	Demonstrace otevírání binárních souborových datových proudů
###########################################################################q
br = o.open('b')    # Jakmile se zadá 'b', 'r' už není implicitní
br = o.open('br');  type(br)  # Otevírám textový soubor ke čtení jako binární
br.read();    br.close()      # Přečtení obsahu a zavření proudu
bw = p.open('bw')   # Otevření souboru pro zápis spojené s odstraněním obsahu
type(bw),    bw.write(b1),    bw.close()    # Zápis dat a zavření proudu
ba = p.open('br+');  ba.read()   # Otevření a přečtení dosavadního obsahu
type(ba),  ba.write(b'_0123456789'),  ba.close()  # Přidání dalšího a zavření
br = p.open('br');    br.read();     br.close()   # Ověření výsledku



#Výpis 11.4:	Demonstrace práce se znakovým paměťovým proudem typu StringIO
###########################################################################q
import io       # Potřebujeme zpřístupnit konstruktory paměťových proudů
s = io.StringIO(t1)  # Textový proud určený ke komunikaci s pamětí
s.read(), s.getvalue()
s.write(' - Ještě přídavek.')   # Zápis dat
print(f'{s.read()=},  {s.getvalue()=}\nJeště jednou: {s.getvalue()=}')
s.close()       # Zavření proudu
s.getvalue()    # Při zavření proud paměť uvolnil, už nejde použít



#Výpis 11.5:	Demonstrace práce s binárním paměťovým proudem typu BytesIO
###########################################################################q
bio = io.BytesIO(b'Jenom kousek demonstrace_')  # Výchozí obsah typu bytes
br = bio.read();   print(f'{type(br)=},  {br = }')
bio.write(b1)
bg = bio.getvalue();   print(f'{type(bg)=}\n{bg = }')
bio.close()



#Výpis 11.0:	Popisek
###########################################################################q
"""
Je uloženo v souboru
#L:/66_INP/xxx.py
"""
##### Kapitola 11.0:	Název
#--------------------------------------------------------------------------q
                                                                       #SYNC
###########################################################################q
dbg.stop_mod(1, __name__)
