#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#L:/66_INP/m13__Dataclass.py
"""
Příkazy zadávané ve výpisech kapitoly:
13  Datové třídy a doprovodný program
"""
import dbg; dbg.start_mod(1, __name__)
###########################################################################q



#Výpis 13.1:	Definice jednoduché datové třídy
###########################################################################q
from dataclasses import *
@dataclass
class Data:
    s:str
    i:int   = 0
    f:float = 0.0

d0=Data('Nic');   d1=Data('Raz', 1);   d2=Data('Dva', 2, 2.0);   (d0, d1, d2)
dx=Data('Nic');   f'{dx=},   {(d0 is dx) = },   {(d0 == dx) = }'



#Výpis 13.2:	Použití proměnných kontejnerů
###########################################################################q
@dataclass
class Demo:
    """Není problém deklarovat pole jako proměnné kontejnery."""
    ls:list     # Pole jako seznam
    st:set      # Pole jako množina
    dc:dict     # Pole jako slovník
    tp:tuple = ([], set(), {})   # Proměnné kontejnery jako prvky n-tice

Demo([1,2], {3,4}, {5:'pět', 6:'šest'})

@dataclass
class Err:
    ls:list = []




#Výpis 13.3:	Použití fiktivního atributu typu KW_ONLY
###########################################################################q
@dataclass
class Point:
    x: float
    _: KW_ONLY
    y: float
    z: float

p = Point(0, z=2.0, y=1.5);   p



#Výpis 13.4:	Definice třídy Rec_Game využívající funkci field() k počítání záznamů
###########################################################################q
@dataclass
class DefaultList:  # Datová třída se seznamem jako implicitní hodnotou
    lst:list = field(default_factory=list)

DefaultList()
@dataclass
class DefaultSet:   # Neprázdná množina jako implicitní hodnota
    nes:set = field(default_factory=lambda : {'not', 'empty', 'set'})

DefaultSet()
#Funkce pro počítání vytvořených záznamů
def id_game(): id_game.id += 1;   return id_game.id

id_game.id = 0  # Funkce si záznamy počítá ve vlastním atributu

@dataclass
class Rec_Game:
    """Záznam o hře s ID autora, názvem a stručným popisem."""
    Gm_Author_ID    :str
    Gm_Name         :str
    Gm_Description  :str
    Gm_ID           :int = field(default_factory=id_game)

g1 = Rec_Game('A1', 'G_1', 'První') # Vytvoříme tři demonstrační záznamy
g2 = Rec_Game('A2', 'G_2', 'Druhá')
g3 = Rec_Game('A3', 'G_3', 'Třetí')
print(f'{g1 = }\n{g2 = }\n{g3 = }') # Kontrola, co se zaznamenalo



#Výpis 13.5:	Příklad definice a použití lambda výrazu s parametrem
###########################################################################q
f2c = lambda fahr: 5 * (fahr - 32) / 9
print('Papír hoří při', round(f2c(451)), '\N{DEGREE CELSIUS}')



#Výpis 13.6:	Datové atributy třídy
###########################################################################q
@dataclass
class DC:   # Datová třída
    s:str = 'default'

class SC:   # Standardní třída s ekvivalentní definicí
    s = 'default'
    def __init__(self, s=s):    # Použije se hodnota s v době definice
        self.s = s
    def __repr__(self):
        return f'SC(s={self.s!r})'
    # Pro úsporu místa vynechávám definici metody __eq__()

print(f'{DC() = },   {DC("init") = },   {DC.s = }\n'
      f'{SC() = },   {SC("init") = },   {SC.s = }')
SC.s = DC.s = 'implicitní'
print(f'{DC() = },   {DC("init") = },   {DC.s = }\n'
      f'{SC() = },   {SC("init") = },   {SC.s = }')
from typing import ClassVar
@dataclass
class DCS:  # Datová třída s explicitně deklarovaným třídním atributem
    s:str = 'default'
    ca:ClassVar[str] = "třídní atribut"

print(f'{DCS() = },   {DCS.s = },   {DCS.ca = }')



#Výpis 13.7:	Pole v hierarchii dědění datových tříd
###########################################################################q
@dataclass
class Mother:
    x: str = 'Něco'
    y: int = 0

@dataclass
class Daughter(Mother):
    z: int = 10
    x: int = 15

Daughter(),    Daughter(1, 2, 3)



#Výpis 13.8:	Přerovnávání zděděných polí při povinném pojmenování
###########################################################################q
@dataclass
class Base:     # Rodičovská třída se dvěma povinně pojmenovanými poli
    a: int = 11     # Hodnota může být zadána pozičně
    _: KW_ONLY      # Hodnoty následujících polí jsou povinně pojmenované
    x: int = 22
    y: int = 33

@dataclass
class Derived(Base):
    b: int = 111    # Hodnota může být zadána pozičně
    z: int = field(kw_only=True, default=222)   # Povinně pojmenované

Derived();   Derived(10, 100);   Derived(x=66, y=77, z=999, a=55, b=888)



#Výpis 13.9:	Využití metody __post_init__()
###########################################################################q
@dataclass
class Area:
    a:float
    b:float
    c:float = field(init=False)
#
    def __post_init__(self):
        self.c = self.a * self.b

Area(2, 3)



#Výpis 13.10:	Využití metody __post_init__() k volání initoru předka
###########################################################################q
@dataclass
class Rectangle:
    width: float
    height: float

@dataclass
class Square(Rectangle):
    side: float
    width: float = field(init=False)
    height: float = field(init=False)
#
    def __post_init__(self):
        super().__init__(self.side, self.side)

Square(5)



#Výpis 13.11:	Datová třída s inicializačním atributem
###########################################################################q
@dataclass
class Point:
    x:float = field(init=False) # Nezadává se, bude se teprve počítat
    y:float = field(init=False) # Totéž
    ampl:   InitVar[float]      # Pomocné proměnné, které se nestanou atributy
    angle:  InitVar[float]      # definují poze argumenty metody __post_init__
#
    def __post_init__(self, ampl, angle):
        """Vypočte hodnoty polí z hodnot zadaných konstruktoru a initoru."""
        from math import sin, cos, tau  # τ = 2 * π  (tau = 2 * pi)
        angle  = angle * tau / 360
        self.x = round(ampl * cos(angle), 3)
        self.y = round(ampl * sin(angle), 3)

Point(0, 0),   Point(1, 90),   Point(1.414, 45)



#Výpis 13.12:	Ukázky použití probraných funkcí
###########################################################################q
@dataclass
class MDemo:
    s:str   = 'string'
    i:int   = '999'
    f:float = 3.1416

md = MDemo();   md
asdict(md)
astuple(md)
replace(md, s='řetězec', i=666)



#Výpis 13.0:	Popisek
###########################################################################q
"""
Je uloženo v souboru
#L:/66_INP/xxx.py
"""
##### Kapitola 13.0:	Název
#--------------------------------------------------------------------------q
                                                                       #SYNC
###########################################################################q
dbg.stop_mod(1, __name__)
