#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#L:/66_INP/m16__CSV.py
"""
Příkazy zadávané ve výpisech kapitoly:
16  Dokumenty ve formátu CSV
"""
import dbg; dbg.start_mod(1, __name__)
###########################################################################q



#Výpis 16.1:	Definice tříd excel, excel_tab, a unix_dialect v modulu csv
###########################################################################q
"""
Je uloženo v souboru
#%PYTHON_311%/Lib/csv.py
"""



#Výpis 16.2:	Definice nového dialektu a ověření výsledku
###########################################################################q
import csv
csv.register_dialect('excel_cz', delimiter=';') # Zavedení potřebného dialektu
csv.list_dialects()       # Seznam názvů doposud registrovaných dialektů
(d := csv.get_dialect('excel_cz'))      # Získání nově definovaného dialektu
print(f'{d.delimiter=}, {d.quotechar=}, {d.doublequote=}, {d.lineterminator=}'
      f'\n{csv.QUOTE_MINIMAL=}, {d.quoting=}, {d.skipinitialspace=}')



#Výpis 16.3:	Přečtení CSV souboru prostřednictvím instance třídy reader
###########################################################################q
dcz = d     # Přesuneme odkaz na dialekt do lépe pojmenované proměnné
with open('DATA/Demo_01E.csv', newline='') as source:
    reader = csv.reader(source, dcz)
    print(type(reader))    # Vytiskne typ načítacího objektu
    for record in reader:
        print(record)      # Načtený záznam převedený na seznam hodnot
        print(' | '.join(record))



#Výpis 16.4:	Přečtení CSV souboru prostřednictvím instance třídy DictReader
###########################################################################q
with open('DATA/Demo_01C.csv', newline='') as source:
    reader = csv.DictReader(source, dialect=dcz)
    print(type(reader))                 # Vytiskne typ načítacího objektu
    for record in reader:
        dbg.prDict(record, dict=True)   # Načtený záznam převedený na slovník

print(f'{reader.line_num=}, {reader.fieldnames=}')



#Výpis 16.5:	Ukázka zápisu CSV a jeho následné načtení
###########################################################################q
import io
names  = ['Celé', 'Reálné', 'Komplexní', 'Text', 'Zvláštní']
record = [1,       2.3,     4+5j,        'Text', 'Odděl, "omez"\na "řádek"']
stream = io.StringIO(newline='')    # Použijeme paměťový datový proud
writer = csv.writer(stream)         # Vytvoříme writer
writer.writerow(names)              # Zapíšeme hlavičku
writer.writerow(record)             # Zapíšeme data (jediný záznam)
print(stream.getvalue())            # Podívám se, co se zapsalo
stream.seek(0)                      # Přesuneme se na začátek proudu
reader = csv.DictReader(stream)     # Otevřeme nad týmž proudem reader
reader.fieldnames # Ptáme se na názvy sloupců, jež načetl při svém vytvoření
dbg.prDict(reader.__next__(), dict=True)    # Přečteme obsah jako CSV
stream.close()                      # Zavřeme datový proud



#Výpis 16.6:	Definice datového typu záznamu
###########################################################################q
"""
Je uloženo v souboru
#L:/66_INP/m16a_Convert.py
"""



#Výpis 16.7:	Převod scénářů na jejich charakteristiky
###########################################################################q
"""
Je uloženo v souboru
#L:/66_INP/m16a_Convert.py
"""



#Výpis 16.8:	Uložení charakteristik do CSV souboru
###########################################################################q
"""
Je uloženo v souboru
#L:/66_INP/m16a_Convert.py
"""



#Výpis 16.9:	Uložení charakteristik scénářů z modulu m16b_Scenarios do CSV souboru
###########################################################################q
import m16a_Convert   as con                    # Modul převodních funkcí
import m16b_Scenarios as scen                   # Slovník převáděných scénářů
records = con.convert_dict(scen.happies)        # Převod do seznamu záznamů
con.write_csv('DATA/scen_charact.csv', records) # Uložení do CSV souboru


#Výpis 16.0:	Popisek
###########################################################################q
"""
Je uloženo v souboru
#L:/66_INP/xxx.py
"""
##### Kapitola 16.0:	Název
#--------------------------------------------------------------------------q
                                                                       #SYNC
###########################################################################q
dbg.stop_mod(1, __name__)
