#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#L:/66_INP/m16a_Convert.py
"""
Dokumentační komentář modulu.
"""
import dbg; dbg.start_mod(1, __name__)
###########################################################################q

from game.api.scenario   import ScenarioStep

from collections import namedtuple

def _Step(command:str, message:str, place:str,
          neighbors:tuple[str], items:tuple[str], bag:tuple[str]):
    """Krok scénáře bez typu kroku."""
    return ScenarioStep(None, command, message, place,
                        neighbors, items, bag)



###########################################################################q

happies = dict(
    adaj07 = (
        _Step('', """\
Vítejte!
Toto je příběh o Draku Šmaku a tobě Hrdino.
Svými příkazy řídíte Hrdinu, aby donesl pohár do vesničky a tam ho zničil.
Nebudete-li si vědět rady, zadejte znak ?.""",
              'Hobitín',
              ('Elfí_hvozd',),
              ('Meč', 'Svačina', 'Neviditelný_plášť', 'Pivo',),
              (),
              )
        
            ,
        _Step('Vezmi Svačina', # Zadaný příkaz
          'Dal sis do batohu objekt: Svačina',
          'Hobitín',    # Aktuální prostor
          ('Elfí_hvozd', ),    # Aktuální sousedé
          ('Meč', 'Neviditelný_plášť', 'Pivo', ), # H-objekty v prostoru
          ('Svačina', ),   # H-Objekty v batohu
          ),
        _Step('Vezmi Neviditelný_plášť',# Zadaný příkaz
          'Dal sis do batohu objekt: Neviditelný_plášť',
          'Hobitín',# Aktuální prostor
          ('Elfí_hvozd', ),# Aktuální sousedé
          ('Meč', 'Pivo', ),# H-objekty v prostoru
          ('Svačina', 'Neviditelný_plášť', ),# H-Objekty v batohu
          ),
        _Step('Jdi Elfí_hvozd',# Zadaný příkaz
          'Hrdina se přesunul do prostoru:\n'
          'Elfí_hvozd, kde číhá nebezpečí na každém rohu',
          'Elfí_hvozd', # Aktuální prostor
          ('Hobitín', 'Jeskyně', ),# Aktuální sousedé
          ('Lebka', 'Kosti', 'Jed', ),# H-objekty v prostoru
          ('Svačina', 'Neviditelný_plášť', ),# H-Objekty v batohu
          ),
        _Step('Jdi Jeskyně',# Zadaný příkaz
          'Hrdina se přesunul do prostoru:\n'
          'Jeskýně s dřímajícím drakem nedozírné velikosti',
          'Jeskyně',# Aktuální prostor
          ('Elfí_hvozd', 'Vesnička', ),# Aktuální sousedé
          ('Drak','pohár',  ),# H-objekty v prostoru
          ('Svačina', 'Neviditelný_plášť', ),# H-Objekty v batohu
          ),
        _Step('Použít Neviditelný_plášť',# Zadaný příkaz
          'Hrdina použil z batohu objekt: Neviditelný_plášť',
          'Jeskyně',# Aktuální prostor
          ('Elfí_hvozd', 'Vesnička',),# Aktuální sousedé
          ('Drak','pohár', ),# H-objekty v prostoru
          ('Svačina', ),# H-Objekty v batohu
          ),
        _Step('Polož Svačina',# Zadaný příkaz
          'Vyndal si z batohu objekt: Svačina',
          'Jeskyně',# Aktuální prostor
          ('Elfí_hvozd', 'Vesnička',),# Aktuální sousedé
          ('Drak','Svačina','pohár', ),# H-objekty v prostoru
          (),# H-Objekty v batohu
          ),
        _Step('Vezmi pohár',# Zadaný příkaz
          'Dal sis do batohu objekt: pohár',
          'Jeskyně',# Aktuální prostor
          ('Elfí_hvozd', 'Vesnička',),# Aktuální sousedé
         ('Drak','Svačina', ),# H-objekty v prostoru
          ('pohár',),# H-Objekty v batohu
          ),
        _Step('Jdi Vesnička',# Zadaný příkaz
          'Hrdina se přesunul do prostoru:\n'
          'Vesnička do které si měl donést pohár.',
          'Vesnička',# Aktuální prostor
          ('Jeskyně', 'Palouček', ),# Aktuální sousedé
          (),# H-objekty v prostoru
          ('Pohár', ),# H-Objekty v batohu
          ),
        _Step('Zničit Pohár',# Zadaný příkaz
          'Hrdina zničil z batohu objekt: pohár',
          'Vesnička',# Aktuální prostor
          ('Jeskyně', 'Palouček', ),# Aktuální sousedé
          (),# H-objekty v prostoru
          (),# H-Objekty v batohu
          ),
        _Step('Konec',
              'Ukončili jste hru.\nDěkujeme, že jste si zahráli.',
              'Vesnička',
              ('Jeskyně','Palouček', ),
              (),
              (),
              ),
    ),

    andv02 = (
        _Step('', """\
Ahoj!
Právě jsi spadl do časové trhliny a ta tě přenesla
o několik milionů let zpátky v čase. Přenesl ses do éry dinosaurů.
Tvým úkolem je najít mládě vzácného Javaptora.
Pokud jsi v nesnázích a nevíš jak dál, napis '?'.""",
          'Jeskyne',  # Aktuální prostor
          ('Strom',),  # Aktuální sousedé
          (),  # H-objekty v prostoru
          (),  # H-Objekty v batohu
          )
    
        ,
    _Step('Jdi strom', # Zadaný příkaz
          'Vstoupil jsi do strom.\n'
            'Vidíš vzácnou rostlinu, možná se ti později bude hodit.',
          'Strom',    # Aktuální prostor
          ('Krovi',  ),    # Aktuální sousedé
          ('Rostlina', 'Houba', ), # H-objekty v prostoru
          (),   # H-Objekty v batohu
          ),
    _Step('Seber rostlina',
          'Do batohu jsi vložil rostlina.',
          'Strom',
          ('Krovi',  ),
          (),
          ('Rostlina', ),
          ),
    _Step('Jdi Krovi',
          'Vstoupil jsi do krovi.\n'
          'Našel jsi bobulky, které ti pomůžou překonat hlad.',
          'Krovi',
          ('Upati_skaly',  ),
          ('Bobulky', 'Houba' ),
          ('Rostlina', ),
          ),
    _Step('Jdi upati_skaly',
          'Vstoupil jsi do upati_skaly.\n'
          'Bronchiosaurus se necítí, že by ti měl pomáhat,tak mu zkus\n'
          'dát rostlinu, kterou jsi našel na stromě',
          'Upati_skaly',
          ('Krovi', 'Skala', ),
          ('Triceraptor',  ),
          ('Rostlina', ),
          ),
    _Step('Batoh',
          'V batohu se nachází rostlina',
          'Upati_skaly',
          ('Krovi', 'Skala', ),
          ('Triceraptor',  ),
          ('Rostlina', ),
          ),
    _Step('Dej rostlina',
          'Odevzdal jsi rostlina',
          'Upati_skaly',
          ('Krovi', 'Skala', ),
          ('Triceraptor',  ),
          (),
          ),
    _Step('Jdi skala',
          'Vstoupil jsi do skala.\n'
          'Našel jsi mládě Javaptora! Vyvolal zpátky časovou trhlinu\n'
          'a dostane tě zpátky domů.',
          'Skala',
          (),
          (),
          (),
          ),
    _Step('Konec',
          'Ukončili jste hru.\nDěkujeme, že jste si zahráli.',
          'Skala',
          (),
          (),
          (),
          ),
    ),

    caka00 = (
        _Step('', """\
Vítejte!\n'
Ocitáš se v roli vojáka, který se chce po krvelačné bitvě
dostat domů za svou rodinou. Svými příkazy řídíte vojáka,
aby se dostal na konec své dobrodružné cesty.
Zadejte znak '?', pokud si nevíte rady, jak hrát dál.""",
      'Krizovatka',
      ('Udoli', 'Mokrady', 'Opusteny_dul',),
      (),
      (),
      )
    ,
    _Step('Jdi opusteny_dul',
      'Jsi v místnosti/lokaci: Opusteny_dul.\n'
      'Po chvíli narazíš na medvěda, který tu spí ve svém brlohu\n'
      'Můžeš se kolem medvěda pokusit proplížit a jít dále do lesa\n'
      'nebo můžeš zpět odkud jsi přišel a jít jinudy.',
      'Opusteny_dul',
      ('Krizovatka', 'Les', ),
      (),
      (),
      ),
    _Step('Jdi les',
      'Jsi v místnosti/lokaci: Les.\n'
      'Zahlédl jsi zde různé byliny, maliny a jahody.\n'
      'Můžeš si je vložit do batohu a pokračovat v cestě.',
      'Les',
      ('Vesnice', ),
      ('Leciva_bylina','Maliny', 'Jahody', ),
      (),
      ),
    _Step('Vezmi leciva_bylina',
      'Do batohu jsi dal předmět: Leciva_bylina',
      'Les',
      ('Vesnice',),
      ('Maliny', 'Jahody', ),
      ('Leciva_bylina', ),
      ),
    _Step('Vezmi maliny',
      'Do batohu jsi dal předmět: Maliny',
      'Les',
      ('Vesnice',),
      ('Jahody', ),
      ('Leciva_bylina', 'Maliny', ),
      ),
    _Step('Jdi vesnice',
      'Jsi v místnosti/lokaci: Vesnice.\n'
      'Jsi vyčerpaný a máš hlad, potřebuješ doplnit síly!\n'
      'Na stole před jedním domem vidíš nějaké jídlo.\n'
      'Můžeš ho sebrat a pak sníst.',
      'Vesnice',
      ('Chyse', 'Hory' ),
      ('Omeleta', 'Kolace' ),
      ('Leciva_bylina', 'Maliny', ),
      ),
    _Step('Vezmi omeleta',
      'Do batohu jsi dal předmět: Omeleta',
      'Vesnice',
      ('Chyse', 'Hory' ),
      ('Kolace' ),
      ('Leciva_bylina', 'Maliny', 'Omeleta', ),
      ),
    _Step('Inventar',
      'V batohu máš tyto předměty: Leciva_bylina, Maliny, Omeleta',
      'Vesnice',
      ('Chyse', 'Hory' ),
      ('Kolace' ),
      ('Leciva_bylina', 'Maliny', 'Omeleta', ),
      ),
    _Step('Snez omeleta',
      'Posilnil ses omeletou, ve které ale byly i otrávené houby\n'
      'Zemřeš, pokud nesníš léčivou bylinu.',
      'Vesnice',
      ('Chyse', 'Hory' ),
      ('Kolace' ),
      ('Leciva_bylina', 'Maliny', ),
      ),
    _Step('Snez leciva_bylina',
      'Zachránil ses léčivou bylinou.',
      'Vesnice',
      ('Chyse', 'Hory' ),
      ('Kolace' ),
      ('Maliny', ),
      ),
    _Step('Jdi hory',
      'Jsi v místnosti/lokaci: Hory.\n'
      'Nyní se musíš dostat přes hory, aby ses konečně shledal se\n'
      'svou rodinou. Avšak hrozí, že vyčerpáním spadneš z některého\n'
      'útesu hor. Posilnil ses předtím nějakým jídlem?',
      'Hory',
      ('Domov' ),
      (),
      ('Maliny', ),
      ),
    _Step('Jdi domov',
      'Jsi v místnosti/lokaci: Domov.\n'
      'Dostal ses ve zdraví přes hory. Domov máš téměř na dosah ruky,\n'
      'ale v tom jsi zahlédl šíleného goblina, jak vyskočil z houští\n'
      'a zajal tvého syna, který si zrovna hrál před domem. Pustí ho\n'
      'pouze tehdy, pokud mu dáš (položíš) nějaké jídlo a odpovíš-li\n'
      'správně na jeho hádanku. Dává ti 3 pokusy, jinak zabije tvého\n'
      'syna a tvá cesta byla k ničemu.\n'
      'Hádanka zní: S lehkostí jde po hladině, však neuměje létat.\n'
      'Tiše pluje pod hladinou, však neumějě dýchat. Ve svitu dne\n'
      'nejmocnější, v noci tiše umírá.',
      'Domov',
      (),
      (),
      ('Maliny', ),
      ),
    _Step('Poloz maliny',
      'Vyndal jsi z batohu: Maliny',
      'Domov',
      (),
      ('Maliny', ),
      (),
      ),
    _Step('Odpovez stin',
      'Správně! Goblin pustil tvého syna, utekl zpátky do své chýše\n'
      'a ty konečně vcházíš se svým synem domů.',
      'Domov',
      (),
      ('Maliny', ),
      (),
      ),
    ),

    dupm01 = (
    _Step('', """\
Vítejte!
Ste archaeológ a při zkoumání starověkého egypta ste šlápli
do pasce a propadli se pod zem. Teď se potřebujete z této pasce dostať.
Zvládnete sa dostať z tajomnej pyramídy a predstaviť ju svetu?
Pokud si nevíš rady jak hrát, použi přikaz "napoveda".""",
          'Rozcesti',  # Aktuální prostor
          ('Hrobka', 'Knihovna', 'Schody',),  # Aktuální sousedé
          ('Sklenice',),  # H-objekty v prostoru
          (),  # H-Objekty v batohu
          ),
    _Step('jdi Hrobka', # Zadaný příkaz
          'Jsi v místnosti Hrobka, děsívé.',
          'Hrobka',    # Aktuální prostor
          ('Rozcesti',),    # Aktuální sousedé
          ('Oltář', 'Klíč','Kniha_Pohadek',), # H-objekty v prostoru
          (),   # H-Objekty v batohu
          ),
    _Step('napoveda', # Zadaný příkaz
          """Ve hře je cílem najít východ z pyramidy,
máte k dispozici malý batoh kam se vejdou 2 věci.
Do batohu můžete přidat věc příkazem vezmi (nazev_veci).
Z batohu můžete věc odebrat příkazem polož (nazev_veci).
Mezi místnostmi se můžete pohybovat příkazem jdi (místnost).
Pokud zapomeneš co všechno můžeš dělat, použi přikaz "napoveda"
Krom toho můžeš na určitých věcech provádět akce precti a odemkni,
na to které, už musíš přijít sám.""",
          'Hrobka',    # Aktuální prostor
          ('Rozcesti',),    # Aktuální sousedé
          ('Oltář', 'Klíč','Kniha_Pohadek',), # H-objekty v prostoru
          (),   # H-Objekty v batohu
          ),
    _Step('vezmi Kniha_Pohadek',
          'Do batohu jsi vložil věc: Kniha_Pohadek',
          'Hrobka',
          ('Rozcesti',),
          ('Oltář','Klíč',),
          ('Kniha_Pohadek',),
          ),
    _Step('vezmi Klíč',
          'Do batohu jsi vložil věc: Klíč',
          'Hrobka',
          ('Rozcesti',),
          ('Oltář',),
          ('Kniha_Pohadek','Klíč',),
          ),
    _Step('polož Kniha_Pohadek',
          'Kniha_Pohadek odebraná z batohu.',
          'Hrobka',
          ('Rozcesti',),
          ('Oltář','Kniha_Pohadek'),
          ('Klíč',),
          ),
    _Step('jdi Rozcesti',
          'Jsi v místnosti Rozcesti, kam to bude?',
          'Rozcesti',
          ('Hrobka', 'Knihovna','Schody',),
          ('Sklenice', ),
          ('Klíč',),
          ),
    _Step('jdi Knihovna',
          'Jsi v místnosti Knihovna, no moc knih tady nezbylo.',
          'Knihovna',
          ('Rozcesti', 'Patro',),
          ('Kniha_Kouzel', ),
          ('Klíč',),
          ),
    _Step('jdi Rozcesti',
          'Jsi v místnosti Rozcesti, kam to bude?',
          'Rozcesti',
          ('Hrobka', 'Knihovna','Schody',),
          ('Sklenice', ),
          ('Klíč',),
          ),
    _Step('jdi Schody',
          'Jsi v místnosti Schody, východ je už na dosah',
          'Schody',
          ('Rozcesti', 'Vychod',),
          (),
          ('Klíč',),
          ),
    _Step('odemkni Vychod',
          'Místnost úspěšně odemčena: Vychod',
          'Schody',
          ('Rozcesti', 'Vychod',),
          (),
          ('Klíč',),
          ),
    _Step('jdi Vychod',
          'Ukončili jste hru.\nDěkujeme, že jste si zahráli.',
          'Vychod',
          ('Schody',),
          (),
          ('Klíč',),
          ),
    ),

dvoj13 = (
    _Step('', """\
Vítej!
Toto je příběh o babičce Viktorii, ke které jsi přišel/la na návštěvu.
Pomocí příkazů musíš sníst a vypít vše, co najdeš, a pak si jít odpočinout na zahradu.
Nezapomeň, že nemáš rád/a banány a že kombinace alkoholu a jídla způsobuje nevolnost.
Nebudeš-li si vědět rady, zadej znak ?.""",
          'Kuchyň',
          ('Obývák', 'Chodba',),
          ('Bratr', 'Banán','Slivovice','Babička','Zbytky od oběda'),
          (),
    )
    ,
    _Step('Pozři Zbytky_od_oběda',
          'Snědl/a jsi: Zbytky od oběda',
          'Kuchyň',
          ('Obývák', 'Chodba', ),
          ('Bratr','Banán','Slivovice','Babička',),
          ('Zbytky_od_oběda', ),
          ),
    _Step('Pozři Slivovice',
          'Dal/a jsi do každé nohy jednu slivovicu s babičkou a opil/a jsi jí. Na zdraví!',
          'Kuchyň',
          ('Chodba','Obývák', ),
          ('Bratr','Banán', 'Babička', ),
          ('Zbytky_od_oběda', 'Slivovice',),
          ),
    _Step('Jdi Chodba',
          'Přesunul/a ses do:\n'
          'Chodba',
          'Chodba',
          ('Zahrada','Kuchyň', 'Ložnice',),
          ('Děda', ),
          ('Zbytky_od_oběda', 'Slivovice',),
          ),
    _Step('Opij Děda',
          'Opil jsi dědu!',
          'Chodba',
          ('Zahrada','Kuchyň', 'Ložnice',),
          ('Děda', ),
          ('Zbytky_od_oběda', 'Slivovice',),
          ),
    _Step('Jdi Zahrada',
          'Přesunul/a ses do:\n'
          'Zahrada',
          'Zahrada',
          ('Chodba', 'Altánek',),
          ('Bazén', 'Trávník', 'Záhonek' ),
          ('Zbytky_od_oběda', 'Slivovice',),
          ),
    _Step('Relaxovat',
          'Relaxuješ - lehl/a sis do trávy a nasál/a jsi vůni kvítí',
          'Zahrada',
          ('Chodba', 'Altánek',),
          ('Bazén', 'Trávník', 'Záhonek' ),
          ('Zbytky_od_oběda', 'Slivovice',),
          ),
    _Step('Vyzvracej Zbytky_od_oběda',
          'Vyzvracel/a jsi zbytky od oběda',
          'Zahrada',
          ('Chodba', 'Altánek',),
          ('Bazén', 'Trávník', 'Záhonek', 'Zbytky_od_oběda' ),
          ('Banán', 'Slivovice',),
          ),
    _Step('Konec',
          'Ukončili jste hru.\nDěkujeme, že jste si zahráli.',
          'Zahrada',
          ('Chodba', 'Altánek',),
          ('Bazén', 'Trávník', 'Záhonek', 'Zbytky_od_oběda', ),
          ('Banán', 'Slivovice',),
          ),
    ),

    fals02 = (
        _Step('', """\
Vítejte v království Pythonas!
Pomožte princezně Jupyterce získat srdce prince Jasona z království Javascriptus.
Navigujte princeznu příkazy a najděte chaloupku baby Javy, která vám umíchá lektvar lásky.
Babě Javě ale musíte donést: sladký úplatek a květ stromu Pusinka.
Nebudete-li si vědět rady, zadejte znak ?.
""",
              'Zámek',
              ('Louka',),
              ('Čokoláda','Zrcadlo','Učebnice_Pythonu', ),
              (),
              ),
        _Step('Vezmi Čokoláda', # Zadaný příkaz
              'Princezna dala do batohu objekt: Čokoláda',
              'Zámek',    # Aktuální prostor
              ('Louka', ),    # Aktuální sousedé
              ('Zrcadlo', 'Učebnice_Pythonu', ), # H-objekty v prostoru
              ('Čokoláda', ),   # H-Objekty v batohu
              ),
        _Step('Jdi Louka',
              'Princezna se přesunula do prostoru:\n'
              'Louka s pampeliškou a sedmikráskou',
              'Louka',
              ('Zámek', 'Údolí', 'Sad', 'Chaloupka',),
              ('Pampeliška', 'Sedmikráska', ),
              ('Čokoláda', ),
              ),
        _Step('Jdi Sad',
              'Princezna se přesunula do prostoru:\n'
              'Sad, ve kterém roste strom Pusinka.',
              'Sad',
              ('Louka', ),
              ('Kámen', 'Strom', 'Květ',),
              ('Čokoláda', ),
              ),
        _Step('Vezmi Květ',
              'Princezna dala do batohu objekt: Květ',
              'Sad',
              ('Louka', ),
              ('Kámen', 'Strom',),
              ('Čokoláda', 'Květ', ),
              ),
        _Step('Jdi Louka',
              'Princezna se přesunula do prostoru:\n'
              'Louka s pampeliškou a sedmikráskou',
              'Louka',
              ('Zámek', 'Údolí', 'Sad', 'Chaloupka',),
              ('Pampeliška', 'Sedmikráska', ),
              ('Čokoláda', 'Květ',),
              ),
        _Step('Jdi Chaloupka',
              'Princezna se přesunula do prostoru:\n'
              'Chaloupka, kde bydlí baba Java',
              'Chaloupka',
              ('Louka',),
              ('Komoda', 'Stůl', 'Java', ),
              ('Čokoláda', 'Květ', ),
              ),
        _Step('Polož Květ',
              'Princezna vyndala z batohu objekt: Květ',
              'Chaloupka',
              ('Louka',),
              ('Komoda', 'Stůl', 'Java','Květ', ),
              ('Čokoláda', ),
              ),
        _Step('Polož Čokoláda',
              'Princezna vyndala z batohu objekt: Čokoláda',
              'Chaloupka',
              ('Louka', ),
              ('Komoda', 'Stůl', 'Java', 'Květ', 'Čokoláda', ),
              (),
              ),
        _Step('Konec',
              'Ukončili jste hru.\nDěkujeme, že jste si zahráli.',
              'Chaloupka',
              ('Louka', ),
              ('Komoda', 'Stůl', 'Java', 'Květ', 'Čokoláda', ),
              (),
              ),
    ),

    hard07 = (
        _Step('', 'Dobré ráno!\n'
            'Je 8:55 a opět jsi zaspal!\n'
            'Nejdříve najdi brýle, protože nevidíš,\n'
            'a zjisti, cos měl dělat!\n'
            'Protože jsi závislý na telefonu, máš volnou jen jednu ruku!\n'
            'Nevíte-li, jak pokračovat, zadejte příkaz ?.',
          'ložnice',
          ('obývák', 'šatna', 'předsíň',),
          ('kniha', 'potvrzení', 'skříň', 'krabice', ),
          (),
    ),
        _Step('jdi obývák',
              'Jsi v mistnosti/prostoru obývák\n',
              'obývák',
              ('ložnice', 'kuchyň', 'koupelna', ),
              ('notebook', 'brýle', 'ovladač', ),
              (),
              ),
        _Step('kam',
              'Můžete jít do ložnice, koupelna, kuchyň\n',
              'obývák',
              ('ložnice', 'koupelna', 'kuchyň', ),
              ('notebook', 'brýle', 'ovladač', ),
              (),
              ),
        _Step('co',
              'Můžeš vzít notebook, brýle, ovladač\n',
              'obývák',
              ('ložnice', 'kuchyň', 'koupelna', ),
              ('notebook', 'brýle', 'ovladač', ),
              (),
              ),
        _Step('vezmi brýle',
              'Vzal(a) jste do ruky objekt brýle',
               'obývák',
              ('ložnice', 'kuchyň', 'koupelna', ),
              ('notebook', 'ovladač', ),
              ('brýle', ),
              ),
        _Step('nasadit brýle',
              'Nasadil(a) jste si brýle',
              'obývák',
              ( 'ložnice', 'kuchyň', 'koupelna', ),
              ('notebook', 'ovladač', ),
              (),
              ),
        _Step('jdi kuchyň',
              'Jsi v mistnosti/prostoru kuchyň\n',
              'kuchyň',
              ('obývák', ),
              ('pánev', 'diář', 'mikrovlnka', ),
              (),
              ),
        _Step('vezmi diář',
              'Vzal(a) jste do ruky objekt diář',
              'kuchyň',
              ('obývák',),
              ('pánev', 'mikrovlnka', ),
              ('diář', ),
              ),
        _Step('přečti diář',
              'Do 9:15 v práci odevzdat potvrzení o studiu!',
              'kuchyň',
              ('obývák',),
              ('pánev', 'mikrovlnka', ),
              ('diář', ),
              ),
        _Step('co_nesu',
              'V ruce máte nyní diář',
              'kuchyň',
              ('obývák',),
              ('pánev', 'mikrovlnka', ),
              ('diář', ),
              ),
        _Step('polož diář',
              'Položil(a) jste diář',
              'kuchyň',
              ('obývák',),
              ('pánev', 'mikrovlnka', 'diář', ),
              (),
              ),
        _Step('jdi obývák',
              'Jsi v mistnosti/prostoru obývák\n',
              'obývák',
              ( 'ložnice', 'kuchyň', 'koupelna', ),
              ('notebook', 'ovladač', ),
              (),
              ),
        _Step('jdi ložnice',
              'Jsi v mistnosti/prostoru ložnice\n',
              'ložnice',
              ('šatna', 'předsíň', 'obývák',),
              ('kniha', 'potvrzení', 'skříň', 'krabice', ),
              (),
              ),
        _Step('vezmi potvrzení',
              'Vzal(a) jste do ruky objekt potvrzení',
              'ložnice',
              ('obývák', 'šatna', 'předsíň', ),
              ('kniha', 'skříň', 'krabice', ),
              ('potvrzení', ),
              ),
        _Step('jdi předsíň',
              'Jsi v mistnosti/prostoru předsíň',
              'předsíň',
              ('ložnice', 'východ',),
              ('hůl', ),
              ('potvrzení',),
              ),
         _Step('jdi východ',
              'Jsi v mistnosti/prostoru východ',
              'východ',
              ('předsíň', ),
              (),
              ('potvrzení', ),
              ),
        _Step('konec',
              'Ukončili jste hru.\n'
              'Děkujeme, že jste si zahráli.',
              'východ',
              ('předsíň', ),
              (),
              ('potvrzení', ),
              ),
    ),

    hruj12 = (
        _Step('', """\
Ahoj, to jsem rád, že tě vidím!
Něco se pokazilo, musíme najít teleport a zmizet nebo tu zůstaneme navždy.
Pokud si nebudeš vědět rady, jak postupovat, napiš znak otazníku. (?)
Jsem ti v patách, ale sám to nezvládnu""",
          'Pláž',
          ('Moře','Hotel'),
          ('Lehátko', 'Brašna', ),
          (),
    ),
        _Step('Otevři brašnu',
              'Otevřel jsi brašnu a z něj vypadly: Klíče, Láhev',
              'Pláž',
              ('Moře','Hotel'),
              ('Lehátko', 'Láhev', 'Klíče', ),
              (),
              ),
        _Step('Vezmi klíče',
              'Vložil jsi do kapsy: Klíče',
              'Pláž',
              ('Moře','Hotel'),
              ('Lehátko', 'Láhev', ),
              ('Klíče', ),
              ),
        _Step('Vezmi láhev',
              'Vložil jsi do kapsy: Láhev',
              'Pláž',
              ('Moře', 'Hotel'),
              ('Lehátko', ),
              ('Klíče', 'Láhev',),
              ),
        _Step('Jdi Hotel',
              'Přesunul ses do prostoru: Hotel\n'
              'Dříve krásný hotel, nyní spíše opuštěná budova\n'
              'se zaparkovaným autem',
              'Hotel',
              ('Pláž', ),
              ('Auto', ),
              ('Klíče', 'Láhev',),
              ),
        _Step('Použij klíče',
              'Odemknul a nastartoval jsi auto',
              'Hotel',
              ('Pláž','Centrála' ),
              ('Odemčené_auto', ),
              ('Láhev',),
              ),
        _Step('Jdi centrála',
              'Přesunul ses do prostoru: Centrála\n'
              'Vědecká centrála, místo, kde se staly\n'
              'v minulosti převratné objevy',
              'Centrála',
              ('Hotel', 'Záchody', ),
              ('Hořící_dveře',  ),
              ('Láhev',),
              ),
        _Step('Jdi záchody',
              'Přesunul ses do prostoru: Záchody\n'
              'Zapáchající , ničím výjimečné záchody',
              'Záchody',
              ('Centrála',),
              ('Umyvadlo', 'Záchod', 'Amulet', ),
              ('Láhev',),
              ),
        _Step('Použij láhev',
              'Naplnil jsi láhev vodou',
              'Zcáhody',
              ('Centrála',),
              ('Umyvadlo', 'Záchod','Amulet', ),
              ('Naplněná_láhev', ),
              ),
        _Step('Vezmi amulet',
              'Vložil jsi do kapsy: Amulet',
              'Zcáhody',
              ('Centrála',),
              ('Umyvadlo', 'Záchod', ),
              ('Naplněná_láhev', 'Amulet', ),
              ),
        _Step('Jdi centrála',
              'Přesunul ses do prostoru: Centrála\n'
              'Vědecká centrála, místo, kde se staly\n'
              'v minulosti převratné objevy',
              'Centrála',
              ('Hotel', 'Záchody',),
              ('Hořící_dveře',),
              ('Naplněná_láhev','Amulet', ),
              ),
        _Step('Použij naplněná_láhev',
              'Uhasil jsi plamen, můžeš jít dál',
              'Centrála',
              ('Hotel', 'Záchody','Teleport'),
              (),
              ('Amulet', ),
              ),
        _Step('Jdi teleport',
              'Přesunul ses do prostoru: Teleport\n'
              'Vynález století, obrvská zářící konstrukce',
              'Teleport',
              ('Centrála',),
              ('Pult'),
              ('Amulet',),
              ),
        _Step('Polož amulet',
              'Položil jsi na ovládací pult Amulet',
              'Teleport',
              ('Centrála', ),
              (),
              (),
              ),
        _Step('Konec',
              'Utekl jsi!\n'
              'Amulet spustil stroj a teleportoval tě do bezpečí\n'
              'Děkujeme, že jste si zahráli.',
              'Teleport',
              ('Centrála', ),
              (),
              (),
              ),
    ),

    hubd02 = (
        _Step('', """\
Vítejte!
Toto je hra o Frodovi, prstenu a černých jezdcích.
Svými příkazy řídíte Froda, aby se bezpečně dostal z Kraje.
Nebudete-li si vědět rady, zadejte znak ?.""",
          'Bilbův_dům',
          ('Lesní_cesta',),
          ('Prsten', 'Krb', ),
          (),
        ),
        _Step('Vezmi prsten', # Zadaný příkaz #Akce
              'Frodo dal do batohu objekt: Prsten',
              'Bilbův_dům',    # Aktuální prostor
              ('Lesní_cesta', ),    # Aktuální sousedé
              ('Krb', ), # H-objekty v prostoru
              ('Prsten', ),   # H-Objekty v batohu
              ),
        _Step('Jdi lesní_cesta', #Prostor
              'Frodo se přesunul do prostoru:\n'
              'Cesta vedoucí lesem se zamrzajícími hřiby, borůvkami',
              'Lesní_cesta',
              ('Bilbův_dům', 'Velká_nora', 'Kukuřičné_pole', ),
              ('Hřiby', 'Borůvky', 'Kámen', ),
              ('Prsten', ),
              ),
        _Step('Vezmi kámen', #Akce
              'Frodo dal do batohu objekt: Kámen',
              'Lesní_cesta',
              ('Lesní_cesta', ),
              ('Hřiby', 'Borůvky', ),
              ('Prsten', 'Kámen', ),
              ),
        _Step('Jdi Velká_nora', #Prostor
              'Frodo se přesunul do prostoru:\n'
              'Velká_nora nacházející se pod kořeny stromu',
              'Velká_nora',
              ('Lesní_cesta', 'Vor', ),
              ('Černý_jezdec', ),
              ('Prsten', 'Kámen', ),
              ),
        _Step('Zahoď kámen', #Akce
              'Frodo zahodil z batohu objekt: Kámen',
              'Velká_nora',
              ('Lesní_cesta', 'Vor', ),
              ('Černý_jezdec', 'Kámen', ),
              ('Prsten', ),
              ),
        _Step('Jdi vor', #Prostor
              'Frodo se přesunul do prostoru:\n',
              'Vor nacházející se na jezeru',
              ('Velká_nora', ),
              ('Zelenina', ),
              ('Prsten', ),
              ),
        _Step('Sněz zelenina', #Akce
              'Frodo snědl  objekt: Zelenina',
              'Vor',
              ('Velká_nora', ),
              (),
              ('Prsten', ),
              ),
        _Step('Polož Prsten', #Akce
              'Frodo vyndal z batohu objekt: Prsten',
              'Vor',
              ('Velká_nora', ),
              ('Prsten', ),
              (),
              ),
        _Step('Konec',
              'Ukončili jste hru.\nDěkujeme, že jste si zahráli.',
              'Vor',
              ('Velká_nora', ),
              ('Prsten', ),
              (),
              ),
        ),

    kanz00 = (
        _Step('', """\
Hello!
'This is history about the king and his daughter.\n'
'And the gay who want to get married to kings daugther.\n'
'King builts tower and saves his daugther .\n'
'In additon hid the key of tower in the forest.\n'
'The guy must find key and open tower to meet daughter.\n'
If you are unsure, enter?.""",
          'House',
          ('Forest',),
          ('Magnet', 'Water', 'Table', 'Navigator', ),
          (),
        ),
        _Step('Take a Magnet',
              'Guy gaves the magnet to the bag: Magnet',
              'House',
              ('Forest', ),
              ('Water', 'Table', 'Navigator', ),
              ('Magnet', ),
              ),
        _Step('Take a Navigator',
              'He gaves the Water to the bag: Navigator',
              'House',
              ('Forest', ),
              ('Table', ),
              ('Magnet','Navigator',),
              ),
        _Step('Search where guy must go',
              'Guy searching where he must go:\n'
              'His navigator show where he must go',
              'House',
              ('Forest',),
              ('Table',  ),
              ('Magnet', 'Navigator', ),
              ),
        _Step('Go Forest',
              'The guy moved into space:\n'
              'Forest, where with strawberries, raspberries',
              'Forest',
              ('Dark_Forest',),
              ('Key', 'Straberries', 'raspberries', ),
              ('Magnet', 'Navigator', ),
              ),
        _Step('Put Magnet',
              'He takes from bag: Magnet',
              'Forest',
              ('Dark_Forest',),
              ('Key', 'Straberries', 'raspberries', ),
              ('Navigator', ),
              ),
        _Step('Take Key ',
              'He gaves the key to the bag: Key',
              'Forest',
              ('Dark_forest', ),
              ('Straberries', 'raspberries', ),
              ('Key','Navigator',),
              ),
        _Step('Go Dark_Forest ',
              'The guy moved into space: \n',
              'Darl_Forest',
              ('Tower', ),
              ('Wolf','Trees', ),
              ('Key','Navigator',),
              ),
        _Step('Kill Wolf ',
              'The guy will kill wolf to pass to tower: \n',
              'Dark_Forest',
              ('Tower', ),
              ('Trees',),
              ('Key','Navigator',),
              ),
        _Step('Go Tower',
              'The guy moved into space:\n'
              'Tower, where daugther is hidden',
              'Tower',
              ('Top Tower',),
              ('Key', ),
              (),
              ),
        _Step('Go Top tower',
              'The guy moved into space:\n'
              'Top tower, where will meet daugther',
              'Top Tower',
              ('House',),
              ('wall'),
              (),
              ),
        _Step('End',
              'You finished game.\nThank you for playing.',
              'Top Tower',
              ('House', ),
              ('Kings Daugther', ),
              (),
              ),
    ),

    kosj08 = (
        _Step('',
                'Babičku napadl vetřelec!\n'
                'Cílem hry je najít meč a vetřelce zabít.\n'
                'Nápověda se otevře symbolem "?".',
          'ústa',
          ('žaludek',),
          ('Zubní_protéza', ),
          (),
        ),
        _Step('zavtipkuj',
              'Jdou dvě babičky a prostřední sežere vlk.',
              'ústa',
              ('žaludek', ),
              ('Zubní_protéza', ),
              (),
              ),
        _Step('jdi žaludek',
              'Bábovka se přesunula do prostoru:\n' +
              'Žaludek, kde se hromadí jídlo od Karkulky, '
              'léky a různé poklady',
              'žaludek',
              ('ústa', 'tenké_střevo', ),
              ('Meč', 'Léky', 'Sushi', 'Bitevní_letoun_AC-130', 'UFO', ),
              (),
              ),
        _Step('vezmi meč',
              'Bábovka dala do batohu objekt: Meč',
              'žaludek',
              ('ústa', 'tenké_střevo', ),
              ('Léky', 'Sushi', 'Bitevní_letoun_AC-130', 'UFO', ),
              ('Meč', ),
              ),
        _Step('jdi tenké_střevo',
              'Bábovka se přesunula do prostoru:\n' +
              'Tenké střevo je fakt hodně tenké',
              'tenké_střevo',
              ('žaludek', 'tlusté_střevo', ),
              (),
              ('Meč', ),
              ),
        _Step('jdi tlusté_střevo',
              'Bábovka se přesunula do prostoru:\n' +
              'Tlusté střevo je fakt hodně tlusté',
              'tlusté_střevo',
              ('tenké_střevo', 'slepé_střevo', ),
              (),
              ('Meč', ),
              ),
        _Step('jdi slepé_střevo',
              'Bábovka se přesunula do prostoru:\n' +
              'A sakra, ve slepém střevě je vetřelec! '
              'Kéž by ho někdo zabil mečem!',
              'slepé_střevo',
              ('tlusté_střevo', ),
              ('Vetřelec', ),
              ('Meč', ),
              ),
        _Step('zavraždi vetřelec',
              'Vetřelec již není vetřelcem!',
              'slepé_střevo',
              ('tlusté_střevo', ),
              (),
              ('Meč', ),
              ),
        _Step('Konec',
              'Zazvonil konec a pohádky je konec!',
              'slepé_střevo',
              ('tlusté_střevo', ),
              (),
              ('Meč', ),
              ),
    ),
    macv10=(
        _Step('', 'Vitajte!\n'
'Do tvojho domčeku v lese – bažiny, sa nasťahovali všetky rozprávkové postavy.\n'
'Zistil si, že ich z ich domovov vyhodil Lord Farkvál, ktorý ich nemá rád\n'
'a chce sa zbaviť všetkých rozprávkových postáv z tohto sveta. Ty – Shrek – chceš\n'
'svoju bažinu naspäť iba pre seba, preto sa rozhodneš zájsť za Lordom Farkválom a požiadať ho,\n'
'aby všetkým postavičkám vrátil naspäť ich domov. On súhlasí pod podmienkou, že vyslobodíš\n'
'princeznú, ktorú si chce zobrať za ženu. Tvojou úlohou je dostať sa do zámku, v ktorom je\n'
'princezná Fiona väznená dračicou. Iba tak si opäť zachrániš svoj domov.\n'
'Napíšte ?, ak si neviete dať rady, ako pokračovať v hre.',
              'bažina',
              ('pole', 'les',),
              ('stolička', 'stôl', 'posteľ',),
              (),
              )
        ,
        _Step('jdi pole',
              'Shrek se presunul do priestoru: pole\n'
              'Pole je pri bažine a pestuje sa tam rôzna zelenina.',
              'pole',
              ('bažina', 'les',),
              ('mrkva', 'zemiaky', 'repka', 'šalát', 'kukurica',),
              (),
              ),
        _Step('vezmi šalát',
              'Shrek dal do batohu predmet: šalát',
              'pole',
              ('bažina', 'les',),
              ('mrkva', 'zemiaky', 'repka', 'kukurica',),
              ('šalát',),
              ),
        _Step('jdi les',
              'Shrek se presunul do priestoru: les\n'
              'Les sa nachádza okolo bažiny a býva v ňom Oslík.',
              'les',
              ('bažina', 'pole', 'čistinka', 'nádvorie',),
              ('Oslík', 'stromy',),
              ('šalát',),
              ),
        _Step('vezmi Oslík',
              'Shrek dal do batohu predmet: Oslík\n',
              'les',
              ('bažina', 'pole', 'čistinka', 'nádvorie',),
              ('stromy',),
              ('šalát', 'Oslík',),
              ),
        _Step('jdi nádvorie',
              'Shrek se presunul do priestoru: nádvorie\n'
              'Nádvorie sa nachádza pred vežou, v ktorej je väznená princezná.',
              'nádvorie',
              ('les', 'dračíbrloh',),
              ('meč',),
              ('šalát', 'Oslík',),
              ),
        _Step('jdi dračíbrloh',
              'Shrek se presunul do priestoru: dračíbrloh\n'
              'V dračom brlohu býva Dračica, ktorá sa stará o to, aby sa k princeznej nikto nedostal.',
              'dračíbrloh',
              ('nádvorie', 'veža',),
              ('Dračica', 'nápis',),
              ('šalát', 'Oslík',),
              ),
        _Step('prečítaj nápis',
              'POZOR! Prečítaj si nápis pozorne, po prečítaní ZMIZNE!\n'
              'Ktokoľvek má záujem navštíviť a vyslobodiť princeznú vo veži má dve možnosti:\n'
              '1. Ak máš nejakú zbraň, môžeš vyzvať dračicu na súboj príkazom použi\n'
              '2. Dračica je osamelá a smutná. Ak jej dáš to, počom túži najviac, pustí ťa k princeznej bez boja.',
              'dračíbrloh',
              ('nádvorie', 'veža',),
              ('Dračica',),
              ('šalát', 'Oslík',),
              ),
        _Step('polož Oslík',
              'Shrek vybral z batohu predmet: Oslík\n'
              'Dračici Oslík okamžite padol do oka! Potešila sa, že už nebude sama.\n'
              'Preto sa rozhodla, že ti odomkne vežu. Môžeš pokračovať za princeznou.',
              'dračíbrloh',
              ('nádvorie', 'veža',),
              ('Dračica', 'Oslík',),
              ('šalát',),
              ),
        _Step('jdi veža',
              'Shrek se presunul do priestoru: veža\n'
              'Úspešne si došiel do veže, v ktorej si našiel princeznú Fionu.\n'
              'Spoločne ste sa vrátili do zámku Lorda Farkvála, ktorý si vzal Fionu za ženu.\n'
              'Svoje slovo dodržal, rozprávkovým postavám vrátil ich domov a Shrek sa mohol vrátiť do svojej bažiny.\n'
              'Gratulujeme! Hru sa vám podarilo vyhrať. Pre ukončenie hry zadajte príkaz "konec".',
              'veža',
              ('dračíbrloh',),
              ('Fiona',),
              ('šalát',),
              ),
        _Step('Konec',
              'Ukončili jste hru.\nDěkujeme, že jste si zahráli.',
              'Chaloupka',
              ('Temný_les',),
              ('Postel', 'Stůl', 'Babička', 'Bábovka', 'Víno',),
              (),
              ),
    ),
    made00 = (
        _Step('', """\
Ahoj, vítej ve hře! Jsi vesmírný pirát, který byl zadržen za své zločiny.
Probudil si se ve své cele ze které chceš uniknout, najít svoji loď a uprchnout z vesmírné stanice.
Zkus se porozhlédnout po cele, jestli najdeš něco, co ti pomůže se z ní dostat. """,
          'Cela',
          ('Chodba',),
          ('Deka', 'Drátek', ),
          (),
    ),
        _Step('Vezmi drátek',
              'Dal si do baťohu objekt: Drátek',
              'Cela',
              ('Chodba', ),
              ('Deka', ),
              ('Drátek', ),
              ),
        _Step('Jdi chodba',
              'Šel si do místnosti:\n'
              'Prázdná chodba',
              'Chodba',
              ('Laboratoř', 'Cela', 'Výslechová_místnost', ),
              ('Regál', ),
              ('Drátek', ),
              ),
        _Step('Polož drátek',
              'Vyndal si z baťohu objekt: Drátek',
              'Chodba',
              ('Laboratoř', 'Výslechová_místnost', ),
              ('Regál', 'Drátek', ),
              ( ),
              ),
        _Step('Jdi laboratoř',
              'Šel si do místnosti:\n'
              'Laboratoř naplňenou různými lektvary',
              'Laboratoř',
              ('Chodba', 'Hangár', ),
              ('Žlutý_lektvar', 'Zelený_lektvar', 'Červený_lektvar',  ),
              (),
              ),
        _Step('Vezmi žlutý_lektvar',
              'Dal sis do baťohu objekt: Žlutý_lektvar',
              'Laboratoř',
              ('Chodba', 'Hangár'),
              ('Zelený_lektvar', 'Červený_lektvar', ),
              ('Žlutý_lektvar', ),
              ),
        _Step('Jdi chodba',
              'Šel si do místnosti:\n'
              'Prázdná chodba',
              'Chodba',
              ('Laboratoř', 'Cela', 'Výslechová_místnost', ),
              ('Regál', 'Drátek', ),
              ('Žlutý_lektvar', ),
              ),
        _Step('Vypij žlutý_lektvar',
              'Vypil si: Žlutý_lektvar',
              'Chodba',
              ('Laboratoř', 'Cela', 'Výslechová_místnost', ),
              ('Regál', 'Drátek', ),
              (),
              ),
         _Step('Jdi výslechová_místnost',
              'Šel si do místnosti:\n'
              'Výslechová místnost, která je plná nepřátel.'
              'Naštestí tě nemůžou vidět,'
              'protože si vypil lektvar neviditelnosti.',
              'Výslechová_místnost',
              ('Chodba', 'Hangár',),
              ('Klíče', 'Židle',  ),
              ( ),
              ),
        _Step('Vezmi klíče',
              'Dal sis do baťohu objekt: Klíče',
              'Výslechová_místnost',
              ('Chodba, Hangár', ),
              ('Židle', ),
              ('Klíče'),
              ),
         _Step('Jdi hangár',
              'Šel si do místnosti:\n'
              'Hangár, kde se nachází vesmírná lod',
              'Hangár',
              ('Výslechová_místnost', 'Laboratoř',),
              ('Loď',  ),
              ('Klíče', ),
              ),
        _Step('Odletět',
              'Podařilo se! Unikl si a vyhrál si hru!',
              'Hangár',
              ('Výslechová_místnost', 'Laboratoř', ),
              ('Loď', ),
              ('Klíče'),
              ),
        _Step('Konec',
              'Ukončil si hru.\nDíky, že sis zahrál.',
              'Hangár',
              ('Výslechová_místnost', 'Laboratoř', ),
              ('Loď', ),
              ('Klíče', )
              ),
    ),
    mecm05 = (
        _Step('', """\
Dobrý dne!
Tato hra pojednává o pošťákovi, který připravuje zásilky k expedici.
Svými příkazy řídíte pošťáka, aby naložil zásilky do transportního kamiónu.
Nebudete-li si vědět rady, zadejte znak ?.""",
          'Podatelna',
          ('Sklad',),
          ('Balík', 'Dopis', 'Počítač', 'Přepážka', ),
          (),
    ),
        _Step('Vezmi balík',
              'Pošťák naložil do vozíku objekt: Balík',
              'Podatelna',
              ('Sklad', ),
              ('Dopis', 'Počítač', 'Přepážka', ),
              ('Balík', ),
              ),
        _Step('Vezmi dopis',
              'Pošťák naložil do vozíku objekt: Dopis',
              'Podatelna',
              ('Sklad', ),
              ('Počítač', 'Přepážka', ),
              ('Balík', 'Dopis', ),
              ),
        _Step('Jdi sklad',
              'Pošťák se přesunul do prostoru:\n'
              'Sklad s kotelnou a regály',
              'Sklad',
              ('Podatelna', 'Rampa', 'Kotelna' ),
              ('Paleta', 'Regály', 'Tiskárna', ),
              ('Balík', 'Dopis', ),
              ),
        _Step('Jdi rampa',
              'Pošťák se přesunul do prostoru:\n'
              'Rampa s kamiónem, jeho řidičem a paletovým vozíkem ',
              'Rampa',
              ('Kamión', 'Sklad', ),
              ('Řidič', 'Paletovač', ),
              ('Balík', 'Dopis', ),
              ),
        _Step('Otevři kamión',
              'Pošťák otevřel kufr od kamiónu',
              'Rampa',
              ('Kamión', 'Sklad', ),
              ('Řidič', 'Paletovač', ),
              ('Balík', 'Dopis', ),
              ),
        _Step('Jdi kamión',
              'Pošťák se přesunula do prostoru:\n'
              'Kamión, kde má vyložit zásilky',
              'Kamión',
              ('Rampa',),
              ('Paleta', 'Kanistr', 'Kurtny', ),
              ('Balík', 'Dopis', ),
              ),
        _Step('Polož balík',
              'Pošťák vyndala z vozíku objekt: Balík',
              'Kamión',
              ('Rampa',),
              ('Paleta', 'Kanystr', 'Kurtny', 'Balík', ),
              ('Dopis', ),
              ),
        _Step('Polož dopis',
              'Pošťák vyndala z vozíku objekt: Dopis',
              'Kamión',
              ('Rampa', ),
              ('Paleta', 'Kanystr', 'Kurtny', 'Balík', 'Dopis', ),
              (),
              ),
        _Step('Jdi rampa',
              'Pošťák se přesunul do prostoru:\n'
              'Rampa s kamiónem, jeho řidičem a paletovým vozíkem ',
              'Rampa',
              ('Kamión', 'Sklad', ),
              ('Řidič', 'Paletovač', ),
              (),
              ),
        _Step('Zavři kamión',
              'Pošťák zavřel kufr od kamiónu',
              'Rampa',
              ('Kamión', 'Sklad', ),
              ('Řidič', 'Paletovač', ),
              (),
              ),
        _Step('Zakřič',
              'Pošťák zakřičel, aby dal znamení řidiči, že může odjet',
              'Rampa',
              ('Kamión', 'Sklad', ),
              ('Řidič', 'Paletovač', ),
              (),
              ),
        _Step('Konec',
              'Jste na konci hry.\nDěkujeme, za pomoc na poště',
              'Kamión',
              ('Rampa', ),
              ('Pleta', 'Kanystr', 'Kurtny', 'Balík', 'Dopis', ),
              (),
              ),
    ),
    melo00 = (
        _Step('', """\
Vítejte!
Dneska vařite DORT na kuchyni master ŠEF!.
Vašim ukolem bude vyhledat, vybrat a udělat všechno potřebne aby VYHRAT SOUTĚŽ.
Budete potřebovat radu, stači zadat ?.
Hodně štěsti!""",
          'Kuchyn',
          ('Lednice','Skřin','Šuplik','Forma na pečeni',),
          ('Prkinko', 'Lžice', 'Núž',  ),
          (),
    ),
        _Step('Vezmi Lžice',
          'Kuchař(ka) dal(a) na kuchynsku linku objekt: Lžice',
          'Kuchyn',    # Aktuální prostor
          ('Lednice','Skřin','Šuplik','Forma na pečeni', ),
          ('Prkinko', 'Núž', ),
          ('Lžice', ),
          ),
    _Step('Otevři Lednice',
          'Kuchař(ka) prohliži a hleda:\n'
          'V lednici se nachazi mlečne vyrobky, vajička, maso a ryba',
          'Lednice',
          ('Kuchyn', ),
          ('Vajička', 'Mleko', 'Syr', 'Maso', 'Ryba', ),
          ('Lžice',),
          ),
    _Step('Vezmi Vajička',
          'Kuchař(ka) loži na kuchnskou linku: Vajička',
          'Lednice',
          ('Kuchyn', ),
          ('Mleko', 'Syr', 'Maso', 'Ryba', ),
          ('Lžice', 'Vajička', ),
          ),
     _Step('Vezmi Mleko',
          'Kuchař(ka) loži na kuchnskou linku: Mleko',
          'Lednice',
          ('Kuchyn',),
          ('Syr', 'Maso', 'Ryba', ),
          ('Lžice', 'Vajička', 'Mleko', ),
          ),
    _Step('Zavři Lednice',
          'Kuchař(ka) zavira ledničku a zase rozhlizi po kuchyni',
          'Kuchyn',
          ('Lednice', 'Skřin','Šuplik','Forma na pečeni', ),
          ('Prkinko', ),
          ('Lžice', 'Vajička', 'Mleko', ),
          ),
    _Step('Otevři Skřin',
          'Kuchař(ka) prohliži a hleda:\n'
          'Ve skřini se nachazi trvanive vyrobky: cukr, krupice, sůl, mouka',
          'Skřin',
          ('Kuchyn', ),
          ('Cukr', 'Krupice', 'Sůl', 'Mouka', ),
          ('Lžice','Vajička', 'Mleko',),
          ),
    _Step('Vezmi Cukr',
          'Kuchař(ka) loži na kuchnskou linku: Cukr',
          'Skřin',
          ('Kuchyn', ),
          ('Krupice', 'Sůl', 'Mouka', ),
          ('Lžice','Vajička', 'Mleko', 'Cukr' ),
          ),
    _Step('Vezmi Mouka',
          'Kuchař(ka) loži na kuchnskou linku: Mouka',
          'Skřin',
          ('Kuchyn',  ),
          ('Krupice', 'Sůl',  'Vajička', 'Mleko', 'Cukr', 'Mouka', ),
          ('Lžice','Vajička', 'Mleko', 'Cukr','Mouka'),
          ),
    _Step('Zavři Skřin',
          'Kuchař(ka) zavira Skřin a zase rozhlizi po kuchyni',
          'Kuchyn',
          ('Lednice', 'Skřin','Šuplik','Forma na pečeni',),
          ('Prkinko', ),
          ('Lžice','Vajička', 'Mleko', 'Cukr','Mouka', ),
          ),
    _Step('Otevři Forma na pečeni',
          'Kuchař(ka) přemyšli co dat do dorta',
          'Forma na pečeni',
          ('Kuchyn', ),
          (),
          ('Lžice','Vajička', 'Mleko', 'Cukr','Mouka',),
          ),
    _Step('Polož Vajička',
          'Kuchař(ka) da vajička do formy na pečeni.\n',
          'Forma na pečeni',
          ('Kuchyn', ),
          ('Vajička',),
          ('Lžice','Mleko', 'Cukr','Mouka', ),
          ),
    _Step('Polož Mleko',
          'Kuchař(ka) da mleko do formy na pečeni.\n',
          'Forma na pečeni',
          ('Kuchyn', ),
          ('Vajička', 'Mleko',),
          ('Lžice', 'Cukr','Mouka', ),
          ),
    _Step('Polož Cukr',
          'Kuchař(ka) da cukr do formy na pečeni.\n',
          'Forma na pečeni',
          ('Kuchyn', ),
          ('Vajička', 'Mleko', 'Cukr',),
          ('Lžice','Mouka', ),
          ),
    _Step('Polož Mouka',
          'Kuchař(ka) da mouka do formy na pečeni.\n',
          'Forma na pečeni',
          ('Kuchyn', ),
          ('Vajička', 'Mleko', 'Cukr','Mouka',),
          ('Lžice',),
          ),
    _Step('Zamichej Lžice',
          'Kuchař(ka) zamicha ingridience lžici a vznikne smes, kterou už si mužete upect',
          'Forma na pečeni',
          ('Kuchyn','Trouba'),
          ('Vajička', 'Mleko', 'Cukr','Mouka','Lžice'),
          ('Smes'),
          ),
    _Step('Otevři Trouba',
          'Kuchař(ka) otevřela troubu.',
          'Trouba',
          ('Forma na pečeni', ),
          (),
          ('Smes',),
          ),
    _Step('Polož Smes',
          'Kuchař(ka) položi smes do trouby.\n',
          'Trouba',
          ('Forma na pečeni', ),
          ('Smes',),
          (),
          ),
    _Step('Konec',
          'Gratulace! Upekli jste dort.\n',
          'Děkujeme, že jste si zahráli.',
          'Trouba',
          ('Smes'),
          (),
          ),
    ),
    micr00 = (
        _Step('', """\
Vítejte!
V této hře hrajete za Honzu, kterého maminka poprosila aby šel do obchodu koupit snídani.
Svými příkazy řídíte Honzu, aby v obchodě nakoupil potraviny a donesl je zpět domů.
Hra začíná u Honzy doma, kde vás maminka požádá aby jste koupil mléko, buchty a sušenky.
Nebudete-li si vědět rady, zadejte znak ?.""",
          'Domov',
          ('ObchodVstup',),
          ('Maminka', 'Peníze',),
          (),
    ),
    _Step('Vezmi peníze',
          'Honza si vzal předmět: Peníze',
          'Domov',
          ('ObchodVstup', ),
          ('Maminka', ),
          ('Peníze', ),
          ),
    _Step('Jdi ObchodVstup',
          'Honza se přesunul do prostoru:\n'
          'Vstup obchodu, kde je kávovar a koš',
          'ObchodVstup',
          ('Pekárna', ),
          ('Kávovar', 'Koš', ),
          ('Peníze', ),
          ),
    _Step('Jdi Pekárna',
          'Honza se přesunul do prostoru:\n'
          'Pekárna, kde lze koupit buchty, chleba a vánočku',
          'Pekárna',
          ('ObchodVstup','Chlazené_zboží',),
          ('Buchty', 'Chleba', 'Vánočka', ),
          ('Peníze',),
          ),
    _Step('Vezmi buchty',
          'Honza si vzal předmět: Buchty',
          'Pekárna',
          ('ObchodVstup','Chlazené_zboží',),
          ('Chleba', 'Vánočka', ),
          ('Peníze','Buchty',),
          ),
    _Step('Jdi Chlazené_zboží',
          'Honza se přesunul do prostoru:\n'
          'Chlazené_zboží, kde lze koupit maso, mléko a sýr',
          'Chlazené_zboží',
          ('Pekárna', 'Cukrovinky',),
          ('Maso', 'Mléko', 'Sýr', ),
          ('Peníze','Buchty',),
          ),
     _Step('Vezmi mléko',
          'Honza si vzal předmět: Mléko',
          'Chlazené_zboží',
          ('Pekárna', 'Cukrovinky',),
          ('Maso','Sýr', ),
          ('Peníze','Buchty','Mléko',),
          ),
    _Step('Jdi Cukrovinky',
          'Honza se přesunul do prostoru:\n'
          'Cukrovinky, kde lze koupit čokoládu, sušenky a lízátko',
          'Cukrovinky',
          ('Chlazené_zboží', 'Hygienické_potřeby','Pokladna',),
          ('Čokoláda', 'Sušenky', 'Lízátko', ),
          ('Peníze','Buchty','Mléko',),
          ),
     _Step('Vezmi sušenky',
          'Honza si vzal předmět: Sušenky',
          'Cukrovinky',
          ('Chlazené_zboží', 'Hygienické_potřeby','Pokladna',),
          ('Čokoláda', 'Lízátko', ),
          ('Peníze','Buchty','Mléko','Sušenky',),
          ),
    _Step('Jdi Pokladna',
          'Honza se přesunul do prostoru:\n'
          'Pokladna, kde může zaplatit za potraviny',
          'Pokladna',
          ('Cukrovinky', 'Hygienické_potřeby',),
          ('Prodavačka', 'Stůl', ),
          ('Peníze','Buchty','Mléko','Sušenky',),
          ),
     _Step('Zkontrolovat',
          'V tašce s nákupem je: Peníze, Buchty, Mléko, Sušenky',
          'Pokladna',
          ('Cukrovinky', 'Hygienické_potřeby',),
          ('Prodavačka', 'Stůl',),
          ('Nákup'),
          ),
    _Step('Polož Buchty',
          'Honza vyndal objekt z batohu: Buchty',
          'Pokladna',
          ('Cukrovinky', 'Hygienické_potřeby',),
          ('Prodavačka', 'Stůl','Buchty', ),
          ('Peníze','Mléko','Sušenky',),
          ),
    _Step('Polož Mléko',
          'Honza vyndal objekt z batohu: Mléko',
          'Pokladna',
          ('Cukrovinky', 'Hygienické_potřeby',),
          ('Prodavačka', 'Stůl','Buchty','Mléko', ),
          ('Peníze','Sušenky',),
          ),
    _Step('Polož Sušenky',
          'Sušenky',
          'Pokladna',
          ('Cukrovinky', 'Hygienické_potřeby',),
          ('Prodavačka', 'Stůl','Buchty','Mléko','Sušenky', ),
          ('Peníze',),
          ),
    _Step('Použít Peníze',
          'Honza zaplatil nákup',
          'Pokladna',
          ('Cukrovinky', 'Hygienické_potřeby',),
          ('Prodavačka', 'Stůl','Buchty','Mléko','Sušenky', ),
          (),
          ),
    _Step('Konec',
          'Ukončili jste hru.\nDěkujeme, že jste si zahráli.',
          'Pokladna',
          ('Cukrovinky', 'Hygienické_potřeby',),
          ('Prodavačka', 'Stůl',),
          ('Nákup'),
          ),
    ),
    ngup11 = (
        _Step('', """\
Království je v ohrožení!\n
Celá jižní část našeho království je od vesničky Werner po Toghe v plamenech.\n
Tvým úkolem je předat Shrekovi z bažiny králův dopis s prosbou o pomoc.\n
Král ti na cestu zapůjčuje koně a posílá do hospody, kde Shrek často pobývá.\n
Nebudeš-li si vědět rady, zadej znak ?.""",
          'Zámek',
          ('Hospoda', ),
          ('Král', 'Dopis', 'Stůl', 'Koruna', 'Zlato', ),
          ('Kůň', ),
    ),
        _Step('Vezmi dopis',
              'Obdržel jsi objekt: Dopis',
              'Zámek',
              ('Hospoda', ),
              ('Král', 'Stůl',),
              ('Kůň', 'Dopis', ),
              ),
        _Step('Jdi hospoda',
              'Nacházíš se v novém prostoru:\nHospoda, kde Shrek často pobývá',
              'Hospoda',
              ('Les',),     # Aktuální sousedé
              ('Mapa', 'Meč', 'Stůl', 'Pivo', 'Tři jablka', ), # H-objekty v prostoru
              ('Kůň', 'Dopis', ),           # H-Objekty v batohu
              ),
        _Step('Vezmi mapa', # Zadaný příkaz
              'Obdžel jsi objekt: Mapa',
              'Hospoda',    # Aktuální prostor
              ('Les', ),    # Aktuální sousedé
              ('Meč', 'Stůl', 'Pivo', 'Tři jablka', ), # H-objekty v prostoru
              ('Kůň', 'Dopis','Mapa', ),   # H-Objekty v batohu
              ),
        _Step('Vezmi meč',
              'Obdžel jsi objekt: Meč',
              'Hospoda',
              ('Les', ),
              ('Stůl', 'Pivo', 'Tři jablka',),
              ('Kůň', 'Dopis','Mapa', 'Meč', ),
              ),
        _Step('Vezmi tři jablka',
              'Obdžel jsi objekt: Tři jablka',
              'Hospoda',
              ('Les', ),
              ('Stůl', 'Pivo', ),
              ('Kůň', 'Dopis','Mapa', 'Meč', 'Tři jablka', ),
              ),
        _Step('Jdi les',
              'V lese, tě přepadnou bandité.\nDále tě pustí jen za podmínkou, že jim necháš svého koně',
              'Les',
              ('Bažina','Shrekův domek', ),
              ('Bandité', ),
              ('Kůň', 'Dopis','Mapa', 'Meč', 'Tři jablka', ),
              ),
        _Step('Opusť kůň',
              'Opustil jsi: kůň',
              'Les',
              ('Bažina', 'Shrekův domek',),
              ('Bandité', ),
              ('Dopis','Mapa', 'Meč', 'Tři jablka', ),
              ),
         _Step('Batoh',
              'V batohu máš: Dopis, Mapa, Meč, Tři jablka',
              'Les',
              ('Bažina', 'Shrekův domek',),
              ('Bandité', ),
              ('Dopis','Mapa', 'Meč', 'Tři jablka', ),
              ),
        _Step('Sněz tři jablka',
            'Použil jsi objekt: tři jablka',
              'Les',
              ('Bažina', 'Shrekův domek',),
              ('Bandité', ),
              ('Dopis','Mapa', 'Meč',  ),
              ),
        _Step('Jdi Bažina',
              'Nacházíš se v novém prostoru:\nBažina s obrovským hadem',
              'Bažina',
              ('Shrekův domek',),
              ('Had' ),
              ('Dopis','Mapa', 'Meč', ),
              ),
        _Step('Jdi Shrekův domek',
              'Nacházíš se v novém prostoru:\nShrekův domek, Shrek není doma',
              'Shrekův domek',
              ('Bažina', ),
              ('Postel', 'Stůl', 'Krb', ),
              ('Dopis','Mapa', 'Meč',),
              ),
        _Step('Polož Dopis',
              'Vyndal jsi z batohu objekt: Dopis',
              'Shrekův domek',
              ('Bažina', ),
              ('Postel', 'Stůl', 'Krb', ),
              ('Mapa', 'Meč', ),
              ),
        _Step('Konec',
              'Dokončil jsi hru.'
              'Podařilo se ti zánést dopis a zachránil jsi tak naše království.',
              'Shrekův domek',
              ('Bažina', ),
              ('Postel', 'Stůl', 'Krb', ),
              ('Mapa', 'Meč', ),
              ),
    ),
    ovcp00 = (
        _Step('', """Vitej!
Tento příběh je o pirátovi notorikovi Rumovousi, který se rozhodl najít
bájny bezedný sud Rumu. Na tobě je, aby jsi mu s jeho výpravou pomohl
a následně se dostal z ostrova a mohl se doma opít se svou opicí Karlem
Pokud si nebudeš vědět rady napiš příkaz pomoc.
Základní příkazy jsou jdi, vezmi, polož, pomoc, otevři, odplout a konec.""",
        'Loď',    # Aktuální prostor
        ('Pláž',),     # Aktuální sousedé
        ('Rum', 'Dřevo', 'Ryba' , 'Stůl'), # H-objekty v prostoru
        (),
    ),
        _Step('Vezmi Rum', # Zadaný příkaz
              'Rumovous si dal do brašny: Rum',
              'Loď',
              ('Pláž' ,),
              ('Dřevo', 'Ryba' , 'Stůl', ), # H-objekty v prostoru
              ('Rum', ),   # H-Objekty v batohu
              ),

        _Step('Jdi Pláž', # Zadaný příkaz
             'Rumovous se přesunul do lokace:\n'
             'Písečná pláž plná písku a kamínků',
             'Pláž',    # Aktuální prostor
             ('Loď' ,'Jeskyně', 'Louka', ),    # Aktuální sousedé
             ('Kamínek', ), # H-objekty v prostoru
             ('Rum', ),   # H-Objekty v batohu
             ),

        _Step('pomoc', # Zadaný příkaz
          '''Hra umožňuje zadat následující příkazy:

Konec
Ukončení hry

jdi
Přesune Rumovouse do zadaného sousedního prostoru.

Polož
Přesune zadaný předmět z brašny do aktuálního prostoru.

Vezmi
Přesune zadaný předmět z aktuálního prostoru do brašny.

Otevři
Otevře daný prostor

odplout
Odplutí z ostrova

pomoc
Zobrazí seznam dostupných akcí spolu s jejich stručnými popisy.
''',
             'Pláž',    # Aktuální prostor
             ('Loď' ,'Jeskyně', 'Louka', ),    # Aktuální sousedé
             ('Kamínek', ), # H-objekty v prostoru
             ('Rum', ),   # H-Objekty v batohu
             ),

        _Step('Jdi Louka', # Zadaný příkaz
            'Rumovous se přesunul do lokace:\n'
            'Rozlehlá louka, odkud je výhled na celý ostrov',
            'Louka',    # Aktuální prostor
            ('Pláž' ,'Pevnost', 'Džungle', ),    # Aktuální sousedé
            ('Strom', ), # H-objekty v prostoru
            ('Rum', ),   # H-Objekty v batohu
            ),

        _Step('otevři Pevnost', # Zadaný příkaz
            'Rumovous otevřel: Pevnost',
            'Louka',    # Aktuální prostor
            ('Pláž' ,'Pevnost', 'Džungle', ),    # Aktuální sousedé
            ('Strom', ), # H-objekty v prostoru
            ('Rum',  ),   # H-Objekty v batohu
            ),

        _Step('Jdi Pevnost', # Zadaný příkaz
            'Rumovous se přesunul do lokace:\n'
            'Starobylá pevnost plná tajemství',
            'Pevnost',    # Aktuální prostor
            ('Louka', ),    # Aktuální sousedé
            ('Bezedný_sud', 'Talíř', ), # H-objekty v prostoru
            ('Rum',  ),   # H-Objekty v batohu
            ),

        _Step('Vezmi bezedný_sud', # Zadaný příkaz
            'Rumovous si dal do brašny: Bezedný_sud',
            'Pevnost',    # Aktuální prostor
            ('Louka' ,),    # Aktuální sousedé
            ('Talíř', ), # H-objekty v prostoru
            ('Rum',  'Bezedný_sud', ),   # H-Objekty v batohu
            ),

        _Step('Jdi Louka', # Zadaný příkaz
            'Rumovous se přesunul do lokace:\n'
            'Rozlehlá louka, odkud je výhled na celý ostrov',
            'Louka',    # Aktuální prostor
            ('Pláž' , 'Pevnost' ,'Džungle', ),    # Aktuální sousedé
            ('Strom', ), # H-objekty v prostoru
            ('Rum',  'Bezedný_sud', ),   # H-Objekty v batohu
            ),

       _Step('Jdi Pláž', # Zadaný příkaz
            'Rumovous se přesunul do lokace:\n'
            'Písečná pláž plná písku a kamínků',
            'Pláž',    # Aktuální prostor
            ('Loď' ,'Jeskyně', 'Louka', ),    # Aktuální sousedé
            ('Kamínek', ), # H-objekty v prostoru
            ('Rum',  'Bezedný_sud', ),   # H-Objekty v batohu
            ),

       _Step('Jdi loď', # Zadaný příkaz
            'Rumovous se přesunul do lokace:\n'
            'Rumovousova soukromá jachta',
            'Loď',    # Aktuální prostor
            ('Pláž', ),    # Aktuální sousedé
            ('Dřevo','Ryba', 'Stůl' , ), # H-objekty v prostoru
            ('Rum',  'Bezedný_sud', ),   # H-Objekty v batohu
            ),

       _Step('Odplout', # Zadaný příkaz
            'Rumovous zvedá kotvu a odplouvá z ostrova domů.\n'
            'Rumovous úspěčně získal svůj vysvěný sud věčného štěstí a již se těší\n'
            'na svého milovaného Opičáka, který na něj doma čeká s prázdnou sklenkou\n'
            'Děkuji ti za zahrání a přeji ti přenádherný den'
            ,
            'Loď',    # Aktuální prostor
            ('Pláž' ,),    # Aktuální sousedé
            ('Dřevo', 'Ryba' ,'Stůl' , ), # H-objekty v prostoru
            ('Rum',  'Bezedný_sud', ),   # H-Objekty v batohu
            ),

    ),
    sedd06 = (
        _Step('', """\
Manželka tě poslala na nákup. Musíš koupit tyto položky:

- Vajíčka
- Mlíko
- Chleba

Vyprav se do Supermarketu a získej všechny suroviny.
Nebudete-li si vědět rady, zadejte znak ?.""",
          'Domov',
          ('Supermarket',),
          ('Manželka','Stůl', ),
          (),
    ),
        _Step('Jdi Supermarket',
              'Přišel jsi do obchodu s potravinami. Nákup můžeš zaplatit u pokladny příkazem Zaplať nákup.',
              'Supermarket',
              ('Domov','Lednice','Pečivo','Nářadí', ),
              ('Pokladna', 'Ostraha', ),
              (),
              ),
        _Step('Jdi Lednice',
              'Přišel jsi k lednici. Příkazem Prohlédni zjistíš jaké potraviny se zde nacházejí.',
              'Lednice',
              ('Supermarket','Pečivo','Nářadí', ),
              ('Vajíčka', 'Mlíko', ),
              (),
              ),
        _Step('Prohlédni',
              'Vidíš následující předměty:\n'
              'vajíčka mlíko ',
              'Lednice',
              ('Supermarket','Pečivo','Nářadí',),
              ('Vajíčka', 'Mlíko', ),
              (),
              ),
        _Step('Vezmi Vajíčka',
              'Vzal jsi předmět: Vajíčka',
              'Lednice',
              ('Supermarket','Pečivo','Nářadí',),
              ('Mlíko', ),
              ('Vajíčka', ),
              ),
        _Step('Vezmi Mlíko',
              'Vzal jsi předmět: Mlíko',
              'Lednice',
              ('Supermarket','Pečivo','Nářadí',),
              (),
              ('Vajíčka','Mlíko',),
              ),
        _Step('Jdi Pečivo',
              'Přišel jsi k pečivu. Příkazem Prohlédni zjistíš jaké potraviny se zde nacházejí.',
              'Pečivo',
              ('Supermarket','Lednice','Nářadí', ),
              ('Chleba', ),
              ('Vajíčka', 'Mlíko', ),
              ),
        _Step('Vezmi Chleba',
              'Vzal jsi předmět: Chleba',
              'Pečivo',
              ('Supermarket','Lednice','Nářadí',),
              (),
              ('Vajíčka','Mlíko','Chleba',),
              ),
        _Step('Jdi Supermarket',
              'Přišel jsi do obchodu s potravinami. Nákup můžeš zaplatit u pokladny příkazem Zaplať nákup.',
              'Supermarket',
              ('Domov','Lednice','Pečivo','Nářadí', ),
              ('Pokladna', 'Ostraha', ),
              ('Vajíčka','Mlíko','Chleba',),
              ),
        _Step('Zaplať nákup',
              'Zaplatil jsi nákup',
              'Supermarket',
              ('Domov','Lednice','Pečivo','Nářadí', ),
              ('Pokladna', 'Ostraha', ),
              ('Vajíčka','Mlíko','Chleba',),
              ),
        _Step('Konec',
              'Ukončil jsi hru.\nDěkuji za hru',
              'Supermarket',
              ('Domov','Lednice','Pečivo','Nářadí', ),
              ('Pokladna', 'Ostraha', ),
              ('Vajíčka','Mlíko','Chleba',),
              ),
    ),
    toka02 = (
        _Step('', """\
Vítejte ve hře "Rano advokata"!
Svými příkazy řídíte asistenta, aby dovezl dokumenty
a oblek advokatovi pro začatek jeho pracovního dne.
Prikazy, ktere muzes zadat: jdi, dej, vezmi, poloz, napoveda, konec.""",
          'Dum',    # Aktuální prostor
          ('Park', ),     # Aktuální sousedé
          ('Dokumenty','Televize', 'Penize','Pas', ), # H-objekty v prostoru
          (),
    ),
      _Step('Vezmi dokumenty',
          'Asistent dal do batohu objekt: Dokumenty',
          'Dum',
          ('Park', ),
          ('Televize', 'Penize', 'Pas', ),
          ('Dokumenty', ),
          ),
      _Step('Vezmi penize',
          'Asistent dal do batohu objekt: Penize',
          'Dum',
          ('Park', ),
          ('Televize', 'Pas', ),
          ('Dokumenty', 'Penize', ),
          ),
     _Step('Jdi park',
          'Asistent se přesunul do prostoru: Park',
          'Park',
          ('Kancelar', 'Cistirna','Dum', ),
          ('Lavice', ),
          ('Dokumenty','Penize', ),
          ),
     _Step('Jdi cistirna',
          'Asistent se přesunul do prostoru: Cistirna',
          'Cistirna',
          ('Park','Obchod', ),
          ('Oblek', ),
          ('Dokumenty','Penize', ),
          ),
     _Step('Dej penize',
          'Asistent vyndal z batohu a dal objekt: Penize',
          'Cistirna',
          ('Park','Obchod', ),
          ('Oblek', ),
          ('Dokumenty', ),
          ),
    _Step('Vezmi oblek',
          'Asistent dal do batohu objekt: Oblek',
          'Cistirna',
          ('Park','Obchod', ),
          (),
          ('Dokumenty', 'Oblek', ),
          ),
     _Step('Batoh',
          'V batohu mas: Dokumenty, Oblek',
          'Cistirna',
          ('Park','Obchod', ),
          (),
          ('Dokumenty', 'Oblek', ),
          ),
     _Step('Jdi park',
          'Asistent se přesunul do prostoru: Park',
          'Park',
          ('Kancelar', 'Cistirna','Dum', ),
          ('Lavice', ),
          ('Dokumenty', 'Oblek', ),
          ),
     _Step('Jdi kancelar',
          'Asistent se přesunul do prostoru: Kancelar',
          'Kancelar',
          ('Park', ),
          ('Advokat', ),
          ('Dokumenty', 'Oblek', ),
          ),
     _Step('Poloz dokumenty',
          'Asistent vyndal z batohu: Dokumenty',
          'Kancelar',
          ('Park', ),
          ('Advokat' ,'Dokumenty', ),
          ('Oblek', ),
          ),
    _Step('Poloz oblek',
          'Asistent vyndal z batohu: Oblek',
          'Kancelar',
          ('Park', ),
          ('Advokat' ,'Dokumenty', 'Oblek', ),
          (),
          ),
      _Step('Konec',
          'Ukončil(a) jste hru.\n'
          'Děkujem, že jste si zahrál(a).',
          'Kancelar',
          ('Park', ),
          ('Advokat' ,'Dokumenty', 'Oblek', ),
          (),
          ),
    ),
    wejj00 = (
        _Step('', """\
Vítejte!
Toto je výuková hra "Uvař si pivo".
Svými příkazy řídíte proces vaření piva, tak abyste úspěšně uvařili zlatavý ležák.
Nebudete-li si vědět rady, zadejte znak ?.""",
          'Domov',
          ('Obchod', ),
          ('Postel', ),
          (),
    ),
        _Step('Jdi obchod',
              'Přesunul jste se do prostoru: Obchod\n' + 'Obchod se surovinamy na vaření piva',
              'Obchod',
              ('Domov', 'Pivovarna', ),
              ('Chmel', 'Slad', 'Kvasnice', 'Káva', ),
              (),
              ),
        _Step('Vezmi slad',
              'Dal jste do tašky: Slad',
              'Obchod',
              ('Domov', 'Pivovarna', ),
              ('Chmel', 'Kvasnice', 'Káva', ),
              ('Slad', ),
              ),
        _Step('Vezmi chmel',
              'Dal jste do tašky: Chmel',
              'Obchod',
              ('Domov', 'Pivovarna', ),
              ('Kvasnice', 'Káva', ),
              ('Slad', 'Chmel', ),
              ),
        _Step('Vezmi kvasnice',
              'Dal jste do tašky: Kvasnice',
              'Obchod',
              ('Domov', 'Pivovarna', ),
              ('Káva', ),
              ('Slad', 'Chmel', 'Kvasnice', ),
              ),
        _Step('Jdi pivovarna',
              'Přesunul jste se do prostoru: Pivovarna',
              'Pivovarna',
              ('Obchod', 'Hospoda', 'Kavárna', ),
              ('Přívod vody', ),
              ('Slad', 'Chmel', 'Kvasnice', ),
              ),
        _Step('Zapni/vypni přívod vody',
              'Zapl jste přívod vody. \n' + 'Voda teče do varné nádoby.',
              'Pivovarna',
              ('Obchod', 'Hospoda', 'Kavárna', ),
              ('Přívod vody', ),
              ('Slad', 'Chmel', 'Kvasnice', ),
              ),
        _Step('Zapni/vypni přívod vody',
              'Vypl jste přívod vody. \n' + 'Varná nádoba je napuštěná.',
              'Pivovarna',
              ('Obchod', 'Hospoda', 'Kavárna', ),
              ('Přívod vody', ),
              ('Slad', 'Chmel', 'Kvasnice', ),
              ),
        _Step('Čekat',
              'Čekáte 30 minut. \n' + 'Voda se ohřívá k teplotě blízké varu.',
              'Pivovarna',
              ('Obchod', 'Hospoda', 'Kavárna', ),
              ('Přívod vody', ),
              ('Slad', 'Chmel', 'Kvasnice', ),
              ),
        _Step('Vlož Slad',
              'Vložil jste do varné nádoby: Slad',
              'Pivovarna',
              ('Obchod', 'Hospoda', 'Kavárna', ),
              ('Přívod vody', 'Slad', ),
              ('Chmel', 'Kvasnice', ),
              ),
        _Step('Vlož Chmel',
              'Vložil jste do varné nádoby: Chmel',
              'Pivovarna',
              ('Obchod', 'Hospoda', 'Kavárna', ),
              ('Přívod vody', 'Slad', 'Chmel', ),
              ('Kvasnice', ),
              ),
        _Step('Vlož Kvasnice',
              'Vložil jste do varné nádoby: Kvasnice',
              'Pivovarna',
              ('Obchod', 'Hospoda', 'Kavárna', ),
              ('Přívod vody', 'Slad', 'Chmel', 'Kvasnice', ),
              (),
              ),
        _Step('Jdi Hospoda',
              'Přesunul jste se do prostoru: Hospoda',
              'Hospoda',
              ('Pivovarna', 'Kavárna', ),
              (),
              (),
              ),
        _Step('Konec',
              'Ukončili jste hru.\n' + 'Děkujeme, že jste si zahráli.',
              'Hospoda',
              ('Pivovarna', 'Kavárna', ),
              (),
              (),
              ),
    ),
    xkuch00 = (
        _Step('', """\
          Vítejte na palubě!\n'
          Toto je příběh o velké námořní výpravě
          Svými příkazy řídíte loď Pintu, karavelu, nejrychlejší ze tří lodí výpravy.
          Cílem hry je najít Nový svět a dopravit tam námořníky, aby se usídlili.
          Na Pintu můžete věci a lidi nalodit (Naloď), vylodit (Vyloď) a plout (Pluj) s ní od místa k místu.
          Jakmile ale doplujete na to správné místo, nezapomeňte zakotvit.
          Během plavby nazapoměnte o námořníky patřičně pečovat, aby cestu zvládli.
          Nebudete-li si vědět rady, zadejte znak ?.
          Příjemnou plavbu !""",
          'Přístav_Palos_de_la_Frontera',               # Aktuální prostor
          ('Ostrov_La_Palma',),                         # Aktuální sousedé
          ('Námořník','Kotva', 'Sud', 'Dřevo', ),   # H-objekty v prostoru
          (),
    ),
        _Step('Naloď Námořník', # Zadaný příkaz, stejný jako vezmi
              'Zadaný předmět nebo osoba byla naloděna: Námořník',
              'Přístav_Palos_de_la_Frontera',    # Aktuální prostor
              ('Ostrov_La_Palma', ),    # Aktuální sousedé
              ('Kotva', 'Sud', 'Dřevo', ), # H-objekty v prostoru
              ('Námořník', ),   # H-Objekty v batohu
              ),
        _Step('Naloď Kotva',
              'Zadaný předmět nebo osoba byla naloděna: Kotva',
              'Přístav_Palos_de_la_Frontera',    # Aktuální prostor
              ('Ostrov_La_Palma', ),    # Aktuální sousedé
              ('Sud', 'Dřevo', ), # H-objekty v prostoru
              ('Námořník', 'Kotva', ),
              ),
        _Step('Pluj Ostrov_La_Palma',
              'Loď Pinta doplula na Ostrov_La_Palma, který\n'
              'je obydlený domorodci a který zužuje živá sopka.\n'
              'Domorodci nabízejí námořníkům  jídlo na další plavbu.',
              'Ostrov_La_Palma',
              ('Přístav_Palos_de_la_Frontera', 'Atlanský_Oceán', ),
              ('Domorodec', 'Jídlo', 'Sopka', ),
              ('Námořník', 'Kotva', ),
              ),
        _Step('Naloď Jídlo',
              'Zadaný předmět nebo osoba byla naloděna: Jídlo',
              'Ostrov_La_Palma',    # Aktuální prostor
              ('Přístav_Palos_de_la_Frontera', 'Atlanský_Oceán', ),    # Aktuální sousedé
              ('Domorodec', 'Sopka', ),
              ('Námořník', 'Kotva','Jídlo',),
              ),
        _Step('Pluj Atlanský_Oceán',
              'Loď Pinta doplula na '
              'Atlanský_Oceán, na kterém se rozpoutala obrovská bouře.\n'
              'Vlny bičovaly Pintu a blesky nad ní žářily.',
              'Atlanský_Oceán',
              ('Ostrov_La_Palma', 'Ostrov_Hispaniola', 'Ostrov_Guanahani', 'Indický_Oceán', ),
              ('Bouře','Blesk', 'Vlny',  ),
              ('Námořník', 'Kotva','Jídlo',),
              ),
        _Step('Sněz Jídlo',
              'jídlo bylo snězeno hladovými námořníky. Bez něj by postupně umírali.\n'
              'Avšak nyní nemají žádné zásoby na delší cestu.',
              'Atlanský_Oceán',
              ('Ostrov_La_Palma', 'Ostrov_Hispaniola', 'Ostrov_Guanahani', 'Indický_Oceán', ),
              ('Bouře','Blesk', 'Vlny',  ),
              ('Námořník', 'Kotva', ),
              ),
        _Step('Pluj Ostrov_Hispaniola',
              'Loď Pinta doplula na '
              'Ostrov_Hispaniola, kde objevila zemi, kterou dosud nikdo neobjevil.',
              'Ostrov_Hispaniola',
              ('Atlanský_Oceán',),
              ('Náčeník', 'Vesnice', 'Jezero', ),
              ('Námořník', 'Kotva', ),
              ),
        _Step('Vyloď Kotva',
              'Byla vyloděna osoba nebo předmět: kotva',
              'Ostrov_Hispaniola',
              ('Atlanský_Oceán',),
              ('Náčeník', 'Vesnice', 'Jezero','Kotva', ),
              ('Námořník', ),
              ),
        _Step('Vyloď Námořník',
              'Byla vyloděna osoba nebo předmět: námořník',
              'Ostrov_Hispaniola',
              ('Atlanský_Oceán',),
              ('Náčeník', 'Vesnice', 'Jezero','Kotva','Námořník', ),
              (),
              ),
        _Step('Konec',
              'Úspěšně jste dopluli do Nového světa a založili první osadu.\n'
              'Hra je paralelou na první objevitelskou výpravu Kryštofa Kolumba,\n'
              'započatou 3.sprna 1492, kdy Kolumbus vyplul do domnělé Indie.\n'
              'Místo toho doplul na dnešní Kubu.',
              'Ostrov_Hispaniola',
              ('Atlanský_Oceán',),
              ('Náčeník', 'Vesnice', 'Jezero','Kotva','Námořník', ),
              (),
              ),
    ),
    xpetp129 = (
        _Step('', """\
Vítejte!
Nyní je rok 2030. Jste Elon Musk cestující v raketě SpaceX.
Virus zničil veškerý Tesla Software ve světě,
žadné back up soubory nejsou.
Potřebujete najít svůj ztracený Tesla Roadster,
který jste poslal do vesmíru v roce 2018,
dostat z auta disk s posledním zbývajicím programovým výbavením
a vratit ho na Zemi.
Abyste z rakety dostali na jakoukoliv planětu ve vesmíru,
budete potřebovat něco, pomoci čeho budete moci dýchat.
Pro otevřeni auta budete následně potřebovat klíč.
Elona Muska můžete řidit pomocí příkazů, které mu pomohou najít jeho auto.
Nebudete-li si vědět rady, zadejte znak ?.""",
          'Raketa',
          ('Měsíc', 'Země', 'Černá_díra', 'Mars'),
          ('skafandr', 'spací_kapsle', 'kyslíková_nádrž'),
          (),
),
        _Step('Vezmi skafandr',
          'Elon Musk vzal objekt: skafandr',
          'Raketa',
          ('Měsíc', 'Země', 'Černá_díra', 'Mars'),
          ('spací_kapsle', 'kyslíková_nádrž'),
          ('skafandr'),
          ),
        _Step('Jdi Mars',
              'Elon Musk se přesunul do prostoru:\n'
              'Stanice na planětě Mars.\n'
              'Už vidite Teslu nedaleko od stanice, ale dovnitř rovnou nemůžete. \n'
              'Potřebujete odemknout dveře klíčem.',
              'Mars',
              ('Raketa'),
              ('Velké_kameny', 'klíč', 'Dveře_auta'),
              ('skafandr'),
              ),
        _Step('Vezmi klíč',
              'Elon Musk vzal objekt: klíč',
              'Mars',
              ('Raketa'),
              ('Velké_kameny', 'klíč', 'Dveře_auta'),
              ('skafandr','klíč' ),
              ),
        _Step('Otevři Dveře_auta',
              'Elon Musk otevřel objekt: Dveře auta',
              'Mars',
              ('Raketa', 'Tesla'),
              ('Velké_kameny', 'Dveře_auta'),
              ('skafandr','klíč'),
              ),
        _Step('Jdi Tesla',
              'Elon Musk se přesunul do prostoru:\n'
              'Tesla Roadster',
              'Tesla',
              ('Mars','Raketa'),
              ('disk', 'manekýn', 'křeslo', 'Dveře_auta'),
              ('skafandr', 'klíč'),
              ),
        _Step('Vezmi disk',
              'Elon Musk vzal objekt: disk',
              'Tesla',
              ('Mars'),
              ('manekýn', 'křeslo', 'Dveře_auta'),
              ('skafandr','klíč', 'disk' ),
              ),
        _Step('Jdi Mars',
              'Elon Musk se přesunul do prostoru:\n'
              'Mars',
              'Mars',
              ('Raketa', 'Tesla'),
              ('Velké_kameny', 'Dveře_auta'),
              ('skafandr','klíč', 'disk'),
              ),
        _Step('Zavři Dveře_auta',
              'Elon Musk zavřel objekt: Dveře_auta',
              'Mars',
              ('Raketa'),
              ('Velké_kameny', 'Dveře_auta'),
              ('skafandr','klíč', 'disk'),
              ),
        _Step('Jdi Raketa',
              'Elon Musk se přesunul do prostoru:\n'
              'Raketa',
              'Raketa',
              ('Měsíc', 'Země', 'Černá_díra', 'Mars'),
              ('spací_kapsle', 'kyslíková_nádrž'),
              ('skafandr', 'klíč', 'disk'),
              ),
        _Step('Jdi Země',
              'Elon Musk se přesunul do prostoru:\n'
              'SpaceX Control Center na Zemi',
              'Země',
              ('Raketa'),
              ('monitory', 'kontrolni_panel'),
              ('skafandr','klíč', 'disk'),
              ),
        _Step('Polož disk',
              'Elon Musk vyndal objekt:\n'
              'disk',
              'Země',
              ('Raketa'),
              ('monitory', 'kontrolni_panel', 'disk'),
              ('skafandr', 'klíč'),
              ),
        _Step('Konec',
              'Ukončili jste hru.\nDěkujeme, že jste si zahráli.',
              'Země',
              ('Raketa'),
              ('monitory', 'kontrolni_panel', 'disk'),
              ('skafandr', 'klíč'),
              ),
    ),
)

###########################################################################q
dbg.stop_mod(1, __name__)
