#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#L:/66_INP/m19__NumPy.py
"""
Příkazy zadávané ve výpisech kapitoly:
19  Knihovna NumPy
"""
import dbg; dbg.start_mod(1, __name__)
###########################################################################q



#Výpis 19.1:	Instalace knihovny NumPy
###########################################################################q
"""
Záznam komunikace s operačním systémem
"""



#Výpis 19.2:	Definice nd polí různých dimenzí
###########################################################################q
import numpy as np  # Knihovna se dle konvence importuje pod názvem np
np.array((1,2,3))   # Jednorozměrné pole, typ prvků odvozen ze zadaných
np.array([[0,1,2],[10,11,12]], dtype=float) # Dvourozměrné pole prvků float
np.array([[(1,2),(3,4)],[(11,22),(33,44)]]) # Třírozměrné pole
np.array([0, 1, 2, 3+0j])    # Typ prvků je odvozen od toho nejobecnějšího
from int2lang import int2cz  # Importuje převod čísla na vyjádření slovy
d = { key: int2cz(key) for key in range(3)}; d  # Slovník prvků (číslo:text)
np.array([list(it) for it in d.items()])  # Generátor vrací seznam seznamů
np.array({11,22,33,44}) # Množina není posloupnost => stává se prvkem
np.array([[1],[11,22]]) # Seznamy mají různý počet prvků => stávají se prvky
np.array(999)   # Bezrozměrné (dimenze=0) pole tvořené skalární hodnotou



#Výpis 19.3:	Datové atributy nd polí
###########################################################################q
def p(a):
    """Pomocná funkce pro tisk hlavních atributů zadaného nd-pole."""
    print(f'{a.ndim=}, {a.shape=}, {a.size=}, {a.dtype=}, {a.itemsize=}')

p(np.array(True))    # Bezrozměrné pole tvořené logickou hodnotou
p(np.array([1+1j]))  # Jednorozměrné pole komplexních čísel
p(np.array([[1,2],[11,12.0]])) # Dvojrozměrné pole reálných čísel
# Následuje trojrozměrné pole celých čísel
p(np.array([[[1,2,3],[11,12,13]],[[101,102,103],[111,112,113]]]))
as111 = np.array([[['x']]]); p(as111)  # 3rozměrné pole stringů tvaru (1,1,1)
np.array([[[]]]) # Pole s jednou plochou, jež má jeden řádek, a ten je prázdný



#Výpis 19.4:	Další způsoby vytvoření nd pole
###########################################################################q
np.empty((2,3)) # Neinicializované pole obsahuje smetí v alokované paměti
np.zeros((2,2), dtype=str)  # Nulové pole stringů
np.ones((1,3), dtype=bool)  # Jedničkové pole logických hodnot
np.identity(3)              # Jednotková matice hodnosti 3
np.arange(10, 30, 5)        # Aritmetická posloupnost celých čísel
np.arange(0, 1.5, 1/3)      # Aritmetická posloupnost reálných čísel
np.linspace(1+0j, 1+1j, 5)  # Aritmetická posloupnost komplexních čísel
np.geomspace(1, 10, num=4)  # Geometrická posloupnost reálných čísel
np.logspace(0, 2, 5)        # Jinak definovaná geometrická posloupnost



#Výpis 19.5:	Vytvoření pole se stejnými daty ale jiným tvarem
###########################################################################q
(a := np.arange(12))        # Výchozí jednorozměrné pole
(a26 := a.reshape(2, 6))    # Pohled na data ve tvary (2,6)
(a34 := a.reshape(3, 4))    # Pohled na data ve tvary (3,4)
(a34t := a34.T)             # Transponovaná matice
(a322 := a.reshape(3,-1,2)) # Prostřední rozměr se dopočítá
a.T     # Transpozice jednorozměrného pole vytvoří stejné pole
# Důkaz, že všechna pole pracují nad týmiž daty
a[1]=11;  a26[1][0]=62;  a34[1][0]=43;  a34t[2][0]=24;  a322[2][0][0]=85;  a
# Alternativní způsob indexace nd-polí (u seznamů a n-tic nepřípustný)
a[1]=1;   a26[1, 0]=6;   a34[1, 0]=4;   a34t[2, 0]=2;   a322[2, 0, 0]=8;   a
(a03 := np.arange(3));  (a31 := a03.reshape((3,1)))   # Převod na sloupcové



#Výpis 19.6:	Různé způsoby slučování polí
###########################################################################q
np.hstack((x:=(1,2,3), y:=np.array((11,22,33)),)) # Vodorovné slučování
np.vstack((x, y))           # Svislé slučování (slučuje sloupce)
np.column_stack((x, y))     # Slučování jednorozměrných polí jako sloupců
a=np.array([[0, 1], [10, 11]]);   b=np.array([[100, 101], [110, 111]]);   a; b
np.hstack((a, b))           # Vodorovné slučování (slučuje řádky)
np.vstack((a, b))           # Svislé slučování (slučuje sloupce)
np.column_stack((a, b))     # Slučování jednorozměrných polí jako sloupců



#Výpis 19.7:	Rozdělení polí na několik menších
###########################################################################q
x = np.array([[0,1,2,3],[10,11,12,13],[20,21,22,23],[30,31,32,33]]);   x
# Rozdělení na dvě pole se stejnými délkami řádků
y = np.hsplit(x,2);   print(f'{y[0]=}\n{y[1]=}')
# Rozdělení na 3 pole s řádky s původními indexy z intervalů [:1], [1:3], [3:]
z = np.vsplit(x, np.array([1, 3]));   print(f'{z[0]=}\n{z[1]=}\n{z[2]=}')



#Výpis 19.8:	Pohledy měnící typ nahlížených hodnot
###########################################################################q
(s  := np.array(['A', 'B', 'C', 'D']))  # Znaky se ukládají v UTF-32
(v1 := s.view(np.int8));     (v4 := s.view(np.int32))
v1[1] = 1   # Změna jednoho z bajtů definujících kód znaku s[0]
print(f'{s[0]=},   {v4[0]=},   {chr(256+65)=}')  # Tisk projevů změny



#Výpis 19.9:	Tvorba pohledů indexováním a vykrajováním
###########################################################################q
y = np.copy(x)      # Hluboká kopie pole `x` z výpisu 19.7
(yv1 := y[1])       # Řádek s indexem 1
(yv2 := y[:2])      # První dva řádky = řádky 0-1
(yv3 := y[:2, 2:])  # Řádky <2, sloupce >=2 - pravá horní čtvrtina pole y
(yv4 := y[:2][2:])  # Řádky <2, z toho pak řádky >=2, takže nic
yv3[1, 0] = 100;    print(f'{yv1!r} <- yv1\n{yv2!r} <- yv2\n{y!r} <- y')



#Výpis 19.10:	Složitější výřezy a rozeznání pohledů vyžadujících vytvoření kopie
###########################################################################q
print(f'{yv1.base is y = },     {yv2.base is y = }\n' # Výřezy z minulého
      f'{yv3.base is y = },     {yv4.base is y = }')  # výpisu jsou pohledy
(yv5 := y[::2, ::2])        # Řádky i sloupce se vybírají s krokem 2
(yv6 := y[[0, 3]])          # Nultý a třetí řádek
(yv7 := y[:, [0, 3]])       # Nultý a třetí sloupec
(yv8 := y[[0,3], [0,3]])    # Prvky [0,0] a [3,3] (nevím proč)
(yv9 := y[[0,3]] [:,[0,3]]) # Prvky z nultého a třetího řádku a sloupce
print(f'{yv5.base is y = },   yv6:{yv6.base},   yv7:{yv7.base.tolist()}\n'
      f'{yv7.base.base = },   yv8:{yv8.base},   yv9:{yv9.base.tolist()},   '
      f'{yv9.base.base = }')  # Jen některé z výřezů jsou čisté pohledy
(yvA := y[[0, 1, 3, 1], [1, 1, 3, 1]]), f'  {yvA.base = }'



#Výpis 19.11:	Tvorba pohledu s větší hodností než má originál
###########################################################################q
from numpy import newaxis   # Přezdívka hodnoty None
print(f'{(None == newaxis) = },     {(None is newaxis) = }')
(v1 := np.array([1, 2, 3])) # Výchozí pole
(v1c := v1[:, None])        # Dvojrozměrné pole s jedním sloupcem
(v1r := v1[newaxis, :])     # Dvojrozměrné pole s jedním řádkem
print(f'{(v1c.base is v1) = },  {(v1r.base is v1) = }')  # Jsou to pohledy



#Výpis 19.12:	Základní operace
###########################################################################q
a01 = np.array([0, 1, 2, 3, 4]);     a10 = np.array([0, 10, 20, 30, 40])
a10 + a01   # Sčítání polí stejného tvaru
a01 ** 2    # Operace se provádějí po prvcích
np.sin(a01 * np.pi/2).round(2)  # Volání funkce - opět po prvcích



#Výpis 19.13:	Získání polí logických hodnot a práce s nimi
###########################################################################q
a10 < 25    # Opět prováděno po prvcích - výsledkem je pole logických hodnot
a10[_]      # Výsledkem indexace logickým polem je výřez s vyhovujícími prvky
a10[(a01 % 2) == 0] # Pole logických hodnot může definovat výřez jiného pole
a10[a01%2==0] = 99; a10 # Změna hodnot ve výřezu definovaném logickým polem



#Výpis 19.14:	Použití operátoru @
###########################################################################q
print(f'{v1 = },   {v1r = }\n{v1c = }')     # Připomenutí polí z výpisu 19.11
v1 * v1     # Součin po prvcích
v1 @ v1     # Skalární součin (1*1 + 2*2 + 3*3) - výsledek je skalár, ne pole
v1 * v1c    # Prvek v řádku násoben vektorem => vyjde sloupec vektorů násobků
v1 @ v1c    # Maticové násobení tvarů (0,3)×(3,1) => (0,1) - vektor
v1c @ v1    # Maticové násobení tvarů (3,1)×(0,3) - CHYBA
v1r @ v1c   # Maticové násobení tvarů (1,3)×(3,1) => (1,1) - matice
v1c @ v1r   # Maticové násobení tvarů (3,1)×(1,3) => (3,3) - matice
_  @  _     # Druhá mocnina výsledku předchozího příkazu (3,3)×(3,3) => (3,3)
v1 + (3.0, 2, 1)    # Typ prvků výsledku je obecnější z typů operandů



#Výpis 19.15:	Ukázky použití složeného přiřazení
###########################################################################q
v1 = np.array((1,2,3)); v1  # Pro jistotu vytvoříme pole znovu
v1 *= 2;                v1  # Operace se skalárem
v1 += (10, 20, 30);     v1  # Operace s AL objektem
v1 *= v1c;              v1  # Změna tvaru pole není přípustná
v1 /= 2;                v1  # Přípustná není ani změna typu prvků pole
v1 = v1 / 2;            v1  # Zde se vytváří nové pole, tam změna nevadí
v1 *= v1;               v1  # Operace prováděná po prvcích
v1 @= v1;               v1  # Maticové násobení zatím není podporované



#Výpis 19.16:	Tisk velkých polí
###########################################################################q
print(ar := np.arange(10_000, dtype=np.int16))
print(ar.reshape(100, 100))
ar.reshape(100, 100)



#Výpis 19.0:	Popisek
###########################################################################q
"""
Je uloženo v souboru
#L:/66_INP/xxx.py
"""
##### Kapitola 19.0:	Název
#--------------------------------------------------------------------------q
                                                                       #SYNC
###########################################################################q
dbg.stop_mod(1, __name__)
