#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#L:/66_INP/m20__Matplotlib.py
"""
Příkazy zadávané ve výpisech kapitoly:
20  Knihovna Matplotlib
"""
import dbg; dbg.start_mod(1, __name__)
###########################################################################q



#Výpis 20.1:	Instalace knihovny Matplotlib
###########################################################################q
"""
Záznam komunikace s operačním systémem
"""



#Výpis 20.2:	Import klíčových modulů této kapitoly
###########################################################################q
import numpy as np              # I zde budeme používat knihovnu NumPy
import matplotlib as mpl        # Základní modul
import matplotlib.pyplot as plt # Důležitý modul s řadou funkcí



#Výpis 20.3:	Význam objektů typu Figure a Axes
###########################################################################q
fig = plt.figure()              # Vytvoření prázdného obrázku
plt.show()       # Otevření okna, po jehož zavření bude program pokračovat
fig, ax = plt.subplots()        # Okno s jedním obrazcem (Axes)
plt.show()                      # Zobrazení právě vytvořeného obrázku
fig, axs = plt.subplots(2, 2)   # Okno s 2x2 obrazci
plt.show()                      # Opět zobrazení právě vytvořeného obrázku



#Výpis 20.4:	Jednoduchý příklad řešený objektově
###########################################################################q
x = np.linspace(0, 2, 100)  # 100 ekvidistančních hodnot z intervalu [0.0; 2.0)
ax = plt.subplot()          # Vytvoří obalový obrázek a příslušný obrazec
ax.plot(x, x,    label='Lineární')      # Umístí data na osy
ax.plot(x, x**2, label='Kvadratická')   # Přidá další data
ax.plot(x, x**3, label='Kubická')       # ... a ještě další
ax.set_xlabel('Hodnota parametru')      # Přidá k vodorovné ose popisek
ax.set_ylabel('Hodnota funkce')         # Přidá popisek ke svislé ose
ax.set_title('Graf několika funkcí')    # Přidá nadpis obrazce
ax.legend()                             # Přidá zobrazení legendy
plt.show()             # Otevře okno pro naformátování a uložení výsledku



#Výpis 20.5:	Týž příklad řešený procedurálně
###########################################################################q
x = np.linspace(0, 2, 100)  # 100 ekvidistančních hodnot z intervalu [0.0; 2.0)
plt.figure()                # Vytvoří objekt obrázku
plt.plot(x, x,    label='Lineární')     # Předá mu data lineární funkce
plt.plot(x, x**2, label='Kvadratická')  # Přidá data kvadratické funkce
plt.plot(x, x**3, label='Kubická')      # ... a nakonec data kubické funkce
plt.xlabel('Hodnota parametru')         # Zadá popisek vodorovné osy
plt.ylabel('Hodnota funkce')            # Zadá popisek svislé osy
plt.title('Graf několika funkcí')       # Přidá nadpis obrázku
plt.legend()                            # Přidá zobrazení legendy
plt.show()             # Otevře okno pro naformátování a uložení výsledku



#Výpis 20.6:	Ukázky formátování vytvořených čar
###########################################################################q
x  = np.linspace(-np.pi, np.pi, 100)
y1 = np.sin(x);          y2 = np.cos(2*x);        y3 = np.sin(x) - np.cos(x)
ax = plt.subplot()
# V jednom volání zadáme zobrazení všech tří závislostí
(l1, l2, l3) = ax.plot(x, y1, x, y2, x, y3) # Obdržíme seznam vytvořených čar
# Upravíme styly čar na čárkovanou, tečkovanou a čerchovanou
l1.set_linestyle('--');  l2.set_linestyle(':');   l3.set_linestyle('-.')
# Upravíme barvy čar na modrou, zelenou a červenou
l1.set_color('b');       l2.set_color('g');       l3.set_color('r')
# Nastavíme šířku čárkované čáry na 1, tečkované na 4 a čerchované na 2
l1.set_linewidth(1);     l2.set_linewidth(4);     l3.set_linewidth(2)
plt.show()



#Výpis 20.7:	Nastavení formátu v argumentu fmt metody plot()
###########################################################################q
ax = plt.subplot()  # Nejprve je třeba znovu vytvořit obrazec
# Pak lze zadat vykreslování potřebných závislostí včetně formátování
(l1, l2, l3) = ax.plot(x, y1, 'b--', x, y2, 'g:', x, y3, 'r-.')
# Síla čar se v argumentu metody plot() nastavit nedá, zadáme ji samostatně
# Současně můžeme zadat texty legendy, které jsme minule vynechali
(l1.set(linewidth=1, label='sin(x)'),
 l2.set(linewidth=4, label='cos(2x)'),
 l3.set(linewidth=2, label='sin(x)-cos(x)'))
ax.legend()     # Nyní má smysl zadat zobrazování legendy
plt.show()



#Výpis 20.8:	Definice podoby značek a volba druhu os
###########################################################################q
x1  = np.linspace(1, 10, 20)
x2  = np.linspace(1, 10, 100)
# Čísla náhodně oscilující kolem exponenciální závislosti
y1 = np.exp(x1 * (np.random.random(20)*0.3 + 0.85))
y2 = np.exp(x2)     # Proložená exponenciální závislost
fig, (aLin, aLog) = plt.subplots(1,2)   # Dva obrazce k porovnání
# V každém obrazci dvě závislosti: spojitá a oscilující bodová náhodná
n1 = aLin.plot(x2, y2);          n2 = aLin.plot(x1, y1, 'ro')
g1 = aLog.plot(x2, y2);          g2 = aLog.plot(x1, y1)
g2[0].set_marker('P')       # Samotné nastavení značky čáru nezruší
g2[0].set_linestyle('')     # Toho dosáhneme až zadáním prázdné čáry
# Pro levý obrazec ponecháme lineární osu, v pravém nastavíme logaritmickou
aLin.set_yscale('linear');       aLog.set_yscale('log')
plt.show()



#Výpis 20.9:	Tvorba sloupcových grafů
###########################################################################q
labels = ['G1', 'G2', 'G3', 'G4', 'G5']     # Popisky značek vodorovné osy
men_means   = [20, 35, 30, 35, 27]          # Hodnoty první závislosti
women_means = [25, 32, 34, 20, 25]          # Hodnoty druhé závislosti
men_std     = [ 2,  3,  4,  1,  2]          # Rozptyl v první závislosti
women_std   = [ 3,  5,  2,  3,  3]          # Rozptyl v druhé závislosti
width = 0.35
fig, (ax1, ax2) = plt.subplots(1, 2)        # Vytvoří dva obrazce

# Připraví podklady pro levý obrazec - kumulovaný graf
o=ax1.bar(labels, men_means,   width, yerr=men_std,   label='Muži')
o=ax1.bar(labels, women_means, width, yerr=women_std, label='Ženy',
          bottom=men_means)    # Základna je nad první hodnotou

# Připraví podklady pro pravý obrazec - paralelní graf
x = np.arange(len(labels))    # Pozice sloupců se budou počítat
rects1 = ax2.bar(x - width/2, men_means,   width, label='Muži')
rects2 = ax2.bar(x + width/2, women_means, width, label='Ženy')
o=ax2.set_xticks(x, labels)   # Čísla v popiscích nahradí texty z `labels`
o=ax2.bar_label(rects1, padding=3)    # Nad sloupcem zobrazí hodnotu ...
o=ax2.bar_label(rects2, padding=3)    # ... odsazenou o 3 body od vrcholu

# Zadá textové popisky
o=ax1.set_title('Kumulovaný sloupcový graf s rozptyly')
o=ax2.set_title('Paralelní sloupcový graf')
o=ax1.set_ylabel('Počet bodů');       o=ax2.set_ylabel('Počet bodů')
o=ax1.legend();                       o=ax2.legend()

plt.show()



#Výpis 20.10:	Vytvoření histogramu
###########################################################################q
mu, sigma = 100, 15
iq = mu + sigma * np.random.randn(10_000)
fig, (ax1, ax2) = plt.subplots(1, 2)
n, b, p = ax1.hist(iq, 100)
n, b, p = ax2.hist(iq, 100, cumulative=True, histtype='step')

ax1.set_xlabel('Naměřené IQ'),            ax2.set_xlabel('Naměřené IQ')
ax1.set_ylabel('Počet'),                  ax2.set_ylabel('Počet')
ax1.set_title('Rozložení IQ v populaci'), ax2.set_title('Distribuční funkce')

plt.show()



#Výpis 20.11:	Vytvoření koláčového grafu
###########################################################################q
labels  = 'Adam', 'Bohouš', 'Cyril', 'David'
sizes   = [15, 30, 45, 10]
explode = (0, 0.2, 0, 0)

ax = plt.subplot()
o=ax.pie(sizes, explode=explode, labels=labels, autopct='%1.1f%%',
         shadow=True, startangle=90, textprops=dict(color="k", weight="bold"))

plt.show()



#Výpis 20.0:	Popisek
###########################################################################q
"""
Je uloženo v souboru
#L:/66_INP/xxx.py
"""
##### Kapitola 20.0:	Název
#--------------------------------------------------------------------------q
                                                                       #SYNC
###########################################################################q
dbg.stop_mod(1, __name__)
