#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#L:/66_INP/m21__pandas.py
"""
Příkazy zadávané ve výpisech kapitoly:
21  Knihovna pandas
"""
import dbg; dbg.start_mod(1, __name__)
###########################################################################q
_ = None



#Výpis 21.1:	Instalace knihovny pandas
###########################################################################q
"""
Záznam komunikace s operačním systémem
"""



#Výpis 21.2:	Import klíčových modulů této kapitoly
###########################################################################q
import numpy  as np     # I zde budeme používat knihovnu NumPy
import pandas as pd     # Základní modul



#Výpis 21.3:	Vytvoření datového rámce
###########################################################################q
df = pd.DataFrame(
    {
        'Česky':      ['nula', 'jedna', 'dva',  'tři',  ],
        'Deutsch':    ['null', 'eins',  'zwei', 'drei', ],
        'English':    ['zero', 'one',   'two',  'three',],
        'Slovensky':  ['nula', 'jedna', 'dva',  'tri',  ],
        'Українська': ['нуль', 'один',  'два',  'три',  ],
    }
);   df



#Výpis 21.4:	Získání série
###########################################################################q
df['Česky']     # Indexujeme datový rámec názvem příslušné série
esper = pd.Series(['nul', 'unu', 'du', 'tri'], name='Esperanto');   esper



#Výpis 21.5:	Jednoduché operace
###########################################################################q
spain = pd.Series(['cero','uno','dos','tres','cuatro','cinco'], name='España')
df['Česky'] + ' - ' + spain    # Rozdílně dlouhé série
print(f'{spain.max()=},   {df["English"].max()=}')
df.describe()



#Výpis 21.6:	Načtení charakteristik scénářů z CSV souboru
###########################################################################q
sch = pd.read_csv('DATA/scen_charact.csv')  # Načtení dat z CSV souboru
sch.head(3);    type(_)    # Tisk prvních tří záznamů
sch.tail(3);    type(_)    # Tisk posledních tří záznamů
sch.dtypes      # Přehled typů dat v jednotlivých sériích
sch.describe()  # Základní charakteristika číselných sérií



#Výpis 21.7:	Neúspěšný pokus o načtení dat ve formátu tabulkového procesoru
###########################################################################q
pd.read_excel('DATA/Demo_CSV_.xlsx')



#Výpis 21.8:	Dodatečná instalace knihovny openpyxl
###########################################################################q
"""
Záznam komunikace s operačním systémem
"""



#Výpis 21.9:	Úspěšné načtení dat ve formátu tabulkového procesoru
###########################################################################q
pd.read_excel('DATA/Demo_CSV_.xlsx')



#Výpis 21.10:	Ukázka použití metody to_csv() k získání stringu ve formátu CSV
###########################################################################q
sch[:3].to_csv(sep=';', decimal=',',  # Ukládá jen první tři záznamy
        columns=['steps', 'places', 'neighbors'], index_label='ID')
print(_)    # Zobrazení vráceného stringu v přehlednějším tvaru



#Výpis 21.11:	Výběr zadaných sloupců
###########################################################################q
long = sch['steps'];   long.head(3)         # Vybrána jediná série (sloupec)
col3 = sch[['ID', 'steps', 'places']];     col3.head(3)     # Více sérií
print(f'{long.shape=},    {type(long)=}\n{col3.shape=},  {type(col3)=}')



#Výpis 21.12:	Výběr záznamů splňujících zadanou podmínku
###########################################################################q
sch[tst:=(sch['steps'] > 15)]   # Scénáře s více než 15 kroky
tst.head(3)                     # První 3 záznamy testovací série
sch[sch['steps'].isin([9, 10])] # Záznamy se zadanými počty kroků



#Výpis 21.13:	Současný výběr řádků a sloupců
###########################################################################q
# Zadané sloupce v záznamech o více jak 200 slovech v odpovědích
sch.loc[sch['message_words']>=200,['ID', 'steps', 'message_words']]
# Každý pátý záznam počínaje třetím, sloupce ID, neighbors a places
sch.iloc[3::5, [0, 6, 4]]



#Výpis 21.14:	Přidání a odstranění série
###########################################################################q
sch['items_avg'] = sch['multi_items'] / sch['steps']
sch[['ID', 'steps', 'multi_items', 'items_avg']].head()
df['Esperanto'] = esper;    df
del df['Česky'];    df.head(2)



#Výpis 21.15:	Přejmenování sloupců a/nebo řádků
###########################################################################q
from int2lang import int2cz         # Import konvertoru čísla na slova
conv = lambda x: int2cz(x).upper()  # Převod na české názvy velkými písmeny
dfc = df.rename(
    columns={'Deutsch':   'Německy',    # Nové názvy definované slovníkem
             'English':   'Anglicky',
             'Українська':'Ukrajinsky'},
    index  = conv                       # Nové názvy definované funkcí
);  dfc    # Na závěr necháme konvertovanou tabulku vypsat



#Výpis 21.16:	Zjištění, nastavení a zobrazení popisu volby display.precision
###########################################################################q
pd.get_option('display.pr')     # Zjištění hodnoty částečně zadané volby
pd.set_option('.*y\.pr', 3)     # Nastavení volby zadané regulárním výrazem
pd.describe_option('.+\.prec')  # Získání popisu voleb zadaných reg. výrazem



#Výpis 21.17:	Zjištění a nastavení volby display.precision alternativním způsobem
###########################################################################q
pd.options.display.precision        # Zjištění dříve nastavené hodnoty
# 3
pd.options.display.precision = 2    # Další zmenšení nastavené hodnoty



#Výpis 21.18:	Použití agregačních funkcí
###########################################################################q
sch['steps'].mean()
sch[['cmd_chars', 'message_words', 'places']].mean()
sch[['steps','cmd_chars','message_words','places','multi_items']].describe()



#Výpis 21.19:	Sdružování statistik podle kategorií
###########################################################################q
sch.groupby('steps').mean().head(5)
sch.groupby(['steps','places'])['neighbors'].count().head(6)



#Výpis 21.0:	Popisek
###########################################################################q
"""
Je uloženo v souboru
#L:/66_INP/xxx.py
"""
##### Kapitola 21.0:	Název
#--------------------------------------------------------------------------q
                                                                       #SYNC
###########################################################################q
dbg.stop_mod(1, __name__)
