#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#L:/66_INP/num2str_cz.py
"""
Definuje funkci pro převod čísel na slovní vyjádření v češtině.
"""
import dbg; dbg.start_mod(1, __name__)
###########################################################################q
# Globální konstanty

# Název rodného (tj. cílového) jazyka zapsaný v daném jazyce
LANGUAGE = 'Česky'

# Mezinárodní dvoupísmenná zkratka označující cílový jazyk
SHORTCUT = 'cz'

# Největší číslo, které je program schopen korektně převést
MAX:int = int(10**240-1)



###########################################################################q
# Globální konstanty

# Názvy čísel do dvaceti
UNITS_CZ = ('',        'jedna',    'dva',       'tři',      'čtyři',
            'pět',     'šest',     'sedm',      'osm',      'devět',
            'deset',   'jedenáct', 'dvanáct',   'třináct',  'čtrnáct',
            'patnáct', 'šestnáct', 'sedmnáct',  'osmnáct',  'devatenáct')

# Názvy desítek
TENS_CZ = (
    '',        '',         'dvacet',    'třicet',   'čtyřicet',
    'padesát', 'šedesát',  'sedmdesát', 'osmdesát', 'devadesát'
)

# Názvy stovek.
HUNDREDS_CZ = (
    '',        'sto',      'dvě stě',   'tři sta',  'čtyři sta',
    'pět set', 'šest set', 'sedm set',  'osm set',  'devět set'
)

# Názvy řádů
ORDERS_CZ = (
    ( '',         '',        ''),
    ( 'tisíc',    'tisíce',  'tisíc'  ),
    ( 'ilion',    'iliony',  'ilionů' ),
    ( 'iliarda',  'iliardy', 'iliard' )
)

# Předpony šestičíslí
SEXTETS = ('',
    #1/6         2/7            3/8            4/9              5/10
    'm',         'b',           'tr',          'kvadr',         'kvint',
    'sext',      'sept',         'okt',        'non',           'dec',
    'undec',     'duodec',       'tredec',     'kvadrdec',      'kvindec',
    'sexdec',    'septendec',    'octodec',    'novemdec',      'vigint',
    'unvigint',  'duovigint',    'trevigint',  'kvadrvigint',   'kvinvigint',
    'sexvigint', 'septenvigint', 'octovigint', 'novemvigint',   'trigint', 
    'untrigint', 'duotrigint',   'tretrigint', 'kvadrtrigint, ','kvintrigint',
    'sextrigint','septentrigint','octotrigint','novemtrigint',  'kvaigint',
           )

# Dodržení rodu
GENDER_CZ =(
    ('',      ''),
    ('jeden', 'jedna'),
    ('dva',   'dvě')
)



############################################################################

#@dbg.prSEd()
def int2cz(number:int) -> str:
    """Převede zadané číslo na slovní vyjádření v češtině,
    přičemž největší převeditelné číslo definuje konstanta MAX
    """
    if (number < 0)  or  (MAX < number):
        raise Exception(f'Lze převádět pouze nezáporná čísla do {MAX}')
    if number == 0:  return "nula"              #==========>
    if number < 20:  return UNITS_CZ[number]    #==========>

    def trios(number:int) -> list[int]:
        """Rozdělí celé číslo na jednotlivé trojice."""
        result = []
        while True:
            result.append(number % 1000)
            result //= 1000
            if result == 0: break

    @dbg.prSEdar()
    def sextet(trio:int, order:int) -> str:
        """Vrátí název řádu zadaného trojčíslí."""
        if trio == 0: return ''     #==========>
        row = (order if order < 2 else     # Jednotky a tisíce
               3     if order % 2 else     # Nedělitelný 2 => jarda
               2)                          # Dělitelný   2 => lion
        col = (0 if trio==1 else
               1 if trio<=4 else 2)
        dbg.prIN(1, f'{order=}, {row=}, {col=}')
        return ' ' + SEXTETS[order // 2] + ORDERS_CZ[row][col]

    @dbg.prSEdar()
    def convert(trio:int, order:int):
        """Převede zadané trojčíslí na string."""
        if trio == 0: return ''     #==========>
        if (trio < 3)  and  order > 0:
            res = GENDER_CZ[trio][1 if (order & 1)  and  (order > 1) else
                                  0] # <- liony a tisíce; ^- jardy
            return res  #======>
        units    = trio %  10   # Počet jednotek
        tens     = trio // 10   # Celkový počet desítek
        hundreds = tens // 10   # Počet pouhých stovek
        tens     = tens %  10   # Počet pouhých desítek
        return ( HUNDREDS_CZ[hundreds]
               + (' '  if (hundreds > 0)  and  (number % 100 > 0)  else '')
               + (UNITS_CZ[10*tens + units]  if tens < 2  else
                 (TENS_CZ[tens] + (' ' if (units > 0)  else '')
                                + UNITS_CZ[units]) )
           )

    trios = []
    order = 0
    while number > 0:
        trio = number % 1000
        trios.append(convert(trio=trio, order=order)
                    + sextet(trio=trio, order=order))
        number //= 1000
        order  +=  1
    dbg.prIN(1, f'Trios před: {trios}')
    for i in range(len(trios)-1,-1,-1):
        if not trios[i]:  del trios[i]
    dbg.prIN(1, f'Trios po:   {trios}')
    result = ' '.join(trios[::-1])
    return result.strip()



###########################################################################q
dbg.stop_mod(1, __name__)
