#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#L:/66_INP/rtc.py
"""
Regular expression test from console.
"""
import dbg; dbg.start_mod(1, __name__
                      +  ' - version 0.01.9029 - 2022-07-01_20-35')
###########################################################################q
# Globální importy
# dbg.prDB(1, f'Načteno: {dbg.now()}')
import re


###########################################################################q
# Globální konstanty

# Znak, kterým v konzolovém režimu ukončujeme fyzický řádek
# Jeho dvojitý výskyt označuje konec logického řádku
# Pokud by se měl vyskytovat ve výrazech či textu, je třeba jej vyměnit
CR = '\\'

# Obsahuje-li nahrazovací výraz pouze tento znak, nebude se nahrazovat
# Pokud by se měl v nahrazovacím výrazu vyskytovat, je třeba jej vyměnit
NO = '§'

# Znak, kterým se indikuje konec logického řádku
EOL = '\N{QUADRANT UPPER RIGHT AND LOWER LEFT AND LOWER RIGHT}' # \u259F


###########################################################################q

# @dbg.prSEd()
def tst(groups=True) -> None:
    """Zjistí požadovaný vyhledávací regulární výraz (regex)
    (při `replace==True` také nahrazovací regulární výraz),
    a text, na nějž se má výraz (výrazy) aplikovat.
    Nalezne všechny výskyty textů odpovídajícího zadanému výrazu.
    Vytiskne zadané texty a při neprázdném nahrazovacím výrazu
    vytiskne i text se zanesenými nahrazeními.
    Je-li zadáno `groups==True`, tak u každého nalezeného textu
    zjistí jeho podskupiny a následně je také vytiskne.
    """
    print('Zadejte:')
    # Načte požadované texty potenciálně rozdělené do více řádků
    inp_expr = enter('Regulární výraz:   ')
    inp_repl = enter('Nahrazovací výraz: ')
    inp_text = enter('Analyzovaný text:  ')

    if inp_repl == [NO]:    inp_repl = []   # Nebude se nahrazovat
    if inp_repl == [NO+NO]: inp_repl = [''] # Nalezený text se smaže

    print(f'{60*"-"}')  # Oddělení vstupu a výstupu
    process_and_print(inp_expr, inp_repl, inp_text, groups)


# @dbg.prSEd()
def enter(prompt:str) -> list[str]:
    """Zjistí požadovaný string a vrátí seznam fyzických řádků,
    na nichž je text rozprostřen.

    Má-li být logický řádek zadán na více fyzických řádcích, je třeba dané
    fyzické řádky s výjimkou posledního ukončovat znakem v proměnné `CR`
    (implicitně zpětným lomítkem).
    Má-li být text rozprostřen v několika logických řádcích,
    musí být každý z těchto logických řádků s výjimkou posledního končit
    dvojicí znaků v proměnné `CR` (implicitně dvojicí zpětných lomítek).
    Na výstupu je tato dvojice znaků nahrazena znakem v proměnné `EOL`
    (implicitně znakem ``'▟'``).
    """
    result = []
    while True:
        x = input(prompt)
        if x and (x[-1] != CR):
            # Neprázdný řádek nekončící CR => poslední řádek
            result.append(x)
            return result               # ==========>
        if (len(x) > 1)  and  x[-2] == CR:
            # Řádek končící dvěma CR => vloží se příznak konec řádku
            result.append(x[:-2] + EOL)
        elif x:
            # Řádek končící jedním CR
            result.append(x[:-1])
        else:
            # Prázdný vstup se považuje za překlep => neukládá se
            pass
        # Pro další řádek připraví výzvu z mezer
        prompt = len(prompt)*' '


# @dbg.prSEd()
def process_and_print(inp_expr:list[str], inp_repl:list[str],
                      inp_text:list[str], groups:bool=True) -> None:
    """Zpracuje zadané texty a vytiskne výsledek.
    Texty jsou zadány jako seznamy fyzických řádků,
    které jsou v případě logického řádku ukončeny znakem v proměnné `EOL`
    (implicitně znakem ``'▟'``). Takto označené konce logických řádků
    budou zaneseny do výsledku jako standardní konce řádku ``\n``.
    Parametr `groups` indikuje požadavek na informace o skupinách.
    """

    # Převod obdržených argumentů na odpovídající stringy
    str_expr = ''.join(inp_expr)    # Zadaný vyhledávací regulární výraz
    str_repl = (    # Zadaný nahrazovací regulární výraz
               ''.join(inp_repl) if inp_repl else None)
    str_text =(''.join(inp_text)    # Zadaný prohledávaný text
                 .replace(EOL, '\n')) # Nahrazení příznaků konce řádku
    reg_expr = re.compile(str_expr) # Překlad na objekt typu re.Pattern
    # Vlastní zpracování regulárních výrazů a dodání informací o výsledku:
    # seznam výskytů, nahrazený text, seznam oddělených textů,
    # seznam informací o skupinách v jednotlivých nalezených textech
    fnd_lst,  rpl_text, sep_texts, sub_groups = \
        process(reg_expr, str_repl, str_text, groups)

    if groups:  # Jsou-li požadovány informace o skupinách ...
        # Sloučí řádky s informacemi o skupinách do jednoho stringu
        subgroups = ''.join(sub_groups)
    else:
        subgroups = ''
    out_text  = rpl_text.replace('\n', EOL+'\n').split('\n')
    prn(inp_expr, inp_repl,  inp_text,  out_text, # ... a vše vytiskne
        fnd_lst,  sep_texts, subgroups)

# Zkrácený název funkce pro interaktivní použití
pap = process_and_print


# @dbg.prSEd()
def process(reg_expr:re.Pattern, str_repl:str, str_text:str, groups:bool
            ) -> tuple[list[str], str, list[str], list[str]]:
    """Aplikuje zadaný regulární výraz `reg_expr` na `str_text` a vrátí:
    - seznam nalezených výskytů textu odpovídajícího vyhledávacímu regexu,
    - string po nahrazení (nebylo-li požadováno, je prázdný),
    - seznam textů oddělených nalezenými výskyty,
    - seznam textů s informacemi o skupinách v jednotlivých výskytech
      (není-li požadován, je prázdný).
    """
    # dbg.prIN(1, f'{reg_expr= }\n'
    #             f'{str_repl = }\n'
    #             f'{str_text = }\n'
    #             f'{groups   = }'
    #         )

    # @dbg.prSEdar()
    def subgroups(match, lgr) -> str:
        """Vrátí text s obsahem podskupin."""
        # dbg.prIN(1, f'{match.groups() = }')
        if lgr == 0:   return ''
        sgr = {}
        for i, g in enumerate(match.groups(),1):
            sgr[i] = g
        result = f'  Skupiny v {match[0]!r}: {sgr}\n'
        named = match.groupdict()
        if named:
            result += f'    Z toho pojmenované: {named}\n'
        return result

    found = []  # Nalezené výskyty
    parts = []  # Části textu mezi výskyty
    subgr = []  # Podskupiny každého výskytu
    aux = reg_expr.split(str_text)
    index = 0
    # Postupně projde všechny výskyty
    for match in reg_expr.finditer(str_text):
        found.append(match.group(0))    # Celý výskyt
        parts.append(aux[index])        # Předchozí text
        groups = match.groups()
        lgr = len(groups)
        if groups:  # Mají se analyzovat skupiny?
            subgr.append(subgroups(match, lgr))
        index += lgr + 1  # Index příštího výskytu odděleného textu
    if index < len(aux):  # Ještě zbývá závěrečný oddělený text
        parts.append(aux[index])
    replaced = reg_expr.sub(str_repl, str_text) if str_repl != None else ''
    return found, replaced, parts, subgr


# @dbg.prSEd()
def prn(expr  :list[str],  replex:list[str],  text:list[str],  replaced :str,
        found :list[str],  parts :list[str],  groups:str = ''):
    """Vytiskne zadané argumenty s příslušnými popisky,
    přičemž u prvních dvou zobrazuje zadané řádkování.
    """
    # dbg.prIN(1, f'{type(expr)=}, {type(replex)=}, \n'
    #             f'{type(text)=}, {type(replaced)=}, \n'
    #             f'{type(found)=}, {type(parts)=}\n'
    #             f'{dbg.prItLn(expr,     "expr = ",     prn=0, rpr=1)}\n'
    #             f'{dbg.prItLn(replex,   "replex = ",   prn=0, rpr=1)}\n'
    #             f'{dbg.prItLn(text,     "text = ",     prn=0, rpr=1)}\n'
    #             f'{dbg.prItLn(replaced, "replaced = ", prn=0, rpr=1)}\n'
    #             f'{dbg.prItLn(found,    "found = ",    prn=0, rpr=1)}\n'
    #             f'{dbg.prItLn(parts,    "parts = ",    prn=0, rpr=1)}\n'
    #             f'{dbg.prItLn(groups,   "groups = ",   prn=0, rpr=0)}'
    #         )

    # @dbg.prSEdar()
    def pr(prompt:str, text:list[str]) -> str:
        """Vrátí string určený k tisku, v němž sloučí prvky zadaného seznamu
        a před každý přidá příslušný prefix, aby byly vytištěny pod sebou.
        """
        result = ''
        prefix = prompt
        indent = len(prompt)*' '
        lines  = len(text)
        for index in range(lines):
            line = text[index]
            if line  and  (line[-1] == '\n'):
                line = line[:-1] + '▟'
            result += prefix + line + '\n'
            prefix  = indent
        return result

    print(pr('Regulární výraz:  ', expr)
        +(pr('Nahrazující výraz:', replex) if replex else '')
        + pr('Analyzovaný text: ', text)
        +(pr('Nahrazený text:   ', replaced) if replex else '')
          + f'Oddělené texty:   {parts}\n'
          + f'Nalezené texty:   {found}'
          + (('\n' + groups) if groups else '\n'),
          end = ''   # ^^^ -- skupiny mají vlastní konec řádku
          )


# @dbg.prSEd()
def cap(comment:str, #Komentář, který se má vytisknout před odpovědí
        inp_expr:list[str], inp_repl:list[str],
        inp_text:list[str], groups:bool=True) -> None:
    """Funkce `pap` s komentářem k vytištění pro výpisy v knize.
    Mnemotechnika: comment and print
    """
    if comment:
        if comment[0] == '\n':  print('\n# ' + comment[1:])
        else:                   print(  '# ' + comment)
    pap(inp_expr, inp_repl, inp_text, groups)



from collections import namedtuple
# LAS = List of arguments
LAS   = namedtuple('LAS', 'comment inp_expr inp_repl inp_text groups',
                   defaults = ['', [],      [],       [],     True])

def bac(*list_of_arguments_set:[LAS]):
    """Dávkové spuštění funkce `pap`, jíž budou posupně předány
    sady argumentů ze zadaného seznamu.
    Mnemotechnika: batch of commands
    """
    for a in list_of_arguments_set:
        cap(a.comment, a.inp_expr, a.inp_repl, a.inp_text, a.groups)



###########################################################################q
dbg.stop_mod(1, __name__)
